(PackageInfo named: 'Universes') postscriptOfRemoval: 'TheWorldMenu cleanUp'!
SystemOrganization addCategory: #'Universes-Browser'!
SystemOrganization addCategory: #'Universes-Client'!
SystemOrganization addCategory: #'Universes-Editor'!
SystemOrganization addCategory: #'Universes-Installers'!
SystemOrganization addCategory: #'Universes-Interface'!
SystemOrganization addCategory: #'Universes-Messages'!
SystemOrganization addCategory: #'Universes-Model'!
SystemOrganization addCategory: #'Universes-Policy'!
SystemOrganization addCategory: #'Universes-Serialization'!
SystemOrganization addCategory: #'Universes-Server'!
SystemOrganization addCategory: #'Universes-Tests'!

!Integer methodsFor: '*universes-model' stamp: 'ls 7/27/2004 17:33'!
uversionEqual: anObject
	^anObject isInteger and: [ self = anObject ]! !

!Integer methodsFor: '*universes-model' stamp: 'ls 7/27/2004 17:33'!
uversionLessThan: anObject
	^anObject isInteger and: [ self < anObject ]! !

Model subclass: #UAccountEditor
	instanceVariableNames: 'username password newPassword newPassword2 newEmail whenDone window fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Editor'!

!UAccountEditor commentStamp: '<historical>' prior: 0!
A tool for editing an account!

!UAccountEditor class methodsFor: 'class initialization' stamp: 'ls 2/13/2005 16:58'!
initialize
	Preferences setWindowColorFor: self name to: (Color r: 0.194 g: 0.645 b: 1.0).! !

!UAccountEditor class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 17:41'!
username: username0  password: password0  email: email0  whenDone: aBlock
	^self basicNew
		username: username0  password: password0  email: email0  whenDone: aBlock;
		yourself! !

!UAccountEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 17:52'!
acceptFields
	fields do: [ :f | f accept ]! !

!UAccountEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 17:40'!
morphicView
	| win column nameRow submitButton passwordRow password1Row password2Row emailRow submitButtonHolder |
	window ifNotNil: [^window].
	win := SystemWindow labelled: 'Account Editor'.
	win model: self.
	column := AlignmentMorph newColumn.
	win addMorph: column frame: (0 @ 0 extent: 1 @ 1).
	nameRow := UInterfaceUtilities 
				makeFieldRowNamed: 'name:'
				getSelector: #username
				setSelector: nil
				isPassword: false
				for: self.
	column addMorphBack: nameRow.
	passwordRow := UInterfaceUtilities 
				makeFieldRowNamed: 'password:'
				getSelector: #password
				setSelector: #password:
				isPassword: true
				for: self.
	column addMorphBack: passwordRow.
	password1Row := UInterfaceUtilities 
				makeFieldRowNamed: 'new password'
				getSelector: #password1
				setSelector: #password1:
				isPassword: true
				for: self.
	column addMorphBack: password1Row.
	password2Row := UInterfaceUtilities 
				makeFieldRowNamed: 'confirm:'
				getSelector: #password2
				setSelector: #password2:
				isPassword: true
				for: self.
	column addMorphBack: password2Row.
	emailRow := UInterfaceUtilities 
				makeFieldRowNamed: 'email:'
				getSelector: #newEmail
				setSelector: #newEmail:
				isPassword: false
				for: self.
	column addMorphBack: emailRow.
	submitButtonHolder := Morph new.	"necessary to keep SystemWindow from screwing up the colors of the button"
	submitButtonHolder
		layoutPolicy: TableLayout new;
		hResizing: #spaceFill;
		borderColor: self defaultBackgroundColor.
	submitButton := UInterfaceUtilities 
				makeButtonWithAction: #submit
				andLabel: 'Submit'
				for: self.
	submitButton
		useSquareCorners;
		borderWidth: 0.
	submitButtonHolder addMorph: submitButton.
	column addMorphBack: submitButtonHolder.
	^window := win! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:52'!
newEmail
	^newEmail! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:53'!
newEmail: anObject
	newEmail := anObject! !

!UAccountEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 17:34'!
noteField: field 
	"note that the receiver has the specified text field"
	fields ifNil: [fields := OrderedCollection new].
	fields add: field! !

!UAccountEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 17:38'!
openInMorphic
	^self morphicView openInWorldExtent:  251@263! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:50'!
password
	^password! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:51'!
password1
	^newPassword! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:51'!
password1: aString
	newPassword := aString asString.
	self changed: #password1.
	^true! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:51'!
password2
	^newPassword2! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:51'!
password2: aString
	newPassword2 := aString asString.
	self changed: #password2.
	^true! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 2/13/2005 16:50'!
password: aString
	password := aString.
	self changed: #password! !

!UAccountEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 17:12'!
returnTrue
	^true! !

!UAccountEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 16:52'!
submit
	self acceptFields.
	newPassword = newPassword2 ifFalse: [
		^self inform: 'new passwords do not match!!' ].
	whenDone value: password value: newPassword value: newEmail
	! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:50'!
username
	^username! !

!UAccountEditor methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 17:40'!
username: username0  password: password0  email: email0  whenDone: aBlock
	username := username0.
	password := password0.
	newPassword := ''.
	newPassword2 := ''.
	newEmail := email0.
	whenDone := aBlock.

! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 18:01'!
window
	^window! !

Model subclass: #UPackageEditor
	instanceVariableNames: 'package whenComplete fields window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Editor'!

!UPackageEditor commentStamp: '<historical>' prior: 0!
A simple GUI for editing a package and then doing something with it.
!

!UPackageEditor class methodsFor: 'class initialization' stamp: 'ls 2/13/2005 16:58'!
initialize
	Preferences setWindowColorFor: self name to: (Color r: 0.194 g: 0.645 b: 1.0).! !

!UPackageEditor class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 16:28'!
package: aPackage  whenComplete: aBlock
	^self basicNew
		package: aPackage  whenComplete: aBlock;
		yourself! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 16:41'!
acceptFields
	fields do: [ :f | f accept ]! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 11/26/2006 11:22'!
categoryString
	^package category printString! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 1/13/2007 14:41'!
categoryString: aText 
	package categoryString: aText asString.
	self changed: #categoryString! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 17:58'!
dependsString
	^self stringForPackageNames: package depends! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 17:59'!
dependsString: aString 
	package depends: (self packageNamesFromString: aString).
	self changed: #dependsString! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:40'!
description
	^package description! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:41'!
description: aString
	package description: aString asString.
	self changed: #description.
	^true! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 8/26/2007 11:30'!
guessSqueakMapID
	| squeakmap map smpackage |
	self acceptFields.
	squeakmap := Smalltalk at: #SMSqueakMap ifAbsent: [
		^self inform: 'SqueakMap not loaded, cannot guess'].
	map := squeakmap default.
	smpackage := map packages detect: [ :smp | smp name = self packageName ] ifNone: [
		^self inform: 'could not find a SqueakMap package named ', self packageName].
	self smidString: smpackage id asString
	! !

!UPackageEditor methodsFor: 'accessors' stamp: 'tfel 9/16/2009 00:22'!
homepageString
	^package homepage
		ifNil: [ '' ]
		ifNotNil: [ package homepage asString ]! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 18:01'!
homepageString: newHomePage
	newHomePage asString = ''
		ifTrue: [ package homepage: nil ]
		ifFalse: [ package homepage: (Url absoluteFromText: newHomePage asString) ].

	self changed: #homepageString! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 17:59'!
maintainer
	^package maintainer! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 18:00'!
maintainer: aStringOrText 
	package maintainer: aStringOrText asString.
	self changed: #maintainer! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 16:34'!
makeFieldGet: getSelector  set: setSelector
	| field fieldHeight |
	fieldHeight := TextStyle default defaultFont pointSize + 8.
		
		
	field := PluggableTextMorph on: self text: getSelector accept: setSelector.
	field extent: 200@fieldHeight.
	field hideScrollBarsIndefinitely.
	field setProperty: #alwaysAccept toValue: true.
	
	fields ifNil: [ fields := OrderedCollection new].
	fields add: field.
	
	^field! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 8/26/2007 11:25'!
makeGuessSMIDButton
	^(UInterfaceUtilities makeButtonWithAction: #guessSqueakMapID  andLabel: 'guess' for: self)
		hResizing: #shrinkWrap! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 8/26/2007 11:24'!
morphicView
	| win column nameRow versionRow urlRow descriptionField submitButton dependsRow homepageRow providesRow maintainerRow categoryRow smidRow |
	window ifNotNil: [ ^window ].
	win := SystemWindow labelled: 'Package Editor'.
	win model: self.

	column := AlignmentMorph newColumn.
	win addMorph: column frame: (0@0  extent:  1@0.6).
	

	nameRow := UInterfaceUtilities makeFieldRowNamed: 'name:' getSelector: #packageName setSelector: #packageName: for: self.
	column addMorphBack: nameRow.
	

	versionRow := UInterfaceUtilities makeFieldRowNamed: 'version:' getSelector: #versionString setSelector: #versionString: for: self.
	column addMorphBack: versionRow.
	
	categoryRow := UInterfaceUtilities makeFieldRowNamed: 'category:' getSelector: #categoryString setSelector: #categoryString: for: self.
	column addMorphBack: categoryRow.
	
	maintainerRow := UInterfaceUtilities makeFieldRowNamed: 'maintainer:' getSelector: #maintainer setSelector: #maintainer: for: self.
	column addMorphBack: maintainerRow.
	
	homepageRow := UInterfaceUtilities makeFieldRowNamed: 'homepage:' getSelector: #homepageString setSelector: #homepageString: for: self.
	column addMorphBack: homepageRow.
	
	smidRow := UInterfaceUtilities makeFieldRowNamed: 'SqueakMap ID:' getSelector: #smidString setSelector: #smidString: for: self.
	smidRow addMorphBack: self makeGuessSMIDButton.
	column addMorphBack: smidRow.
	

	
	urlRow := UInterfaceUtilities makeFieldRowNamed: 'download from:' getSelector: #urlString setSelector: #urlString: for: self.
	column addMorphBack: urlRow.

	providesRow := UInterfaceUtilities makeFieldRowNamed: 'provides:' getSelector: #providesString setSelector: #providesString: for: self.
	column addMorphBack: providesRow.
	
	dependsRow := UInterfaceUtilities makeFieldRowNamed: 'depends:' getSelector: #dependsString setSelector: #dependsString: for: self.
	column addMorphBack: dependsRow.

	column addMorphBack: (StringMorph contents: 'Description:').
	
	descriptionField := self makeFieldGet: #description set: #description:.
	win addMorph: descriptionField frame: (0@0.6 extent: 1@0.3).
	
	submitButton := UInterfaceUtilities makeButtonWithAction: #submit andLabel: 'Submit' for: self.
	win addMorph: submitButton frame: (0@0.9 extent: 1@0.1).
	
	
	^window := win! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 17:34'!
noteField: field 
	"note that the receiver has the specified text field"
	fields ifNil: [fields := OrderedCollection new].
	fields add: field! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 8/26/2007 11:21'!
openInMorphic
	^self morphicView openInWorldExtent:  592@557! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:45'!
package
	^package! !

!UPackageEditor methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 16:28'!
package: aPackage  whenComplete: aBlock
	package := aPackage.
	whenComplete := aBlock.
	! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:38'!
packageName
	^package name! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:43'!
packageName: aString
	package name: aString asString.
	self changed: #packageName.
	^true! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 17:59'!
packageNamesFromString: aString 
	| depNames |
	depNames := aString asString findTokens: ','.
	depNames := depNames collect: [:d | d withBlanksTrimmed].
	^depNames! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 17:59'!
providesString
	^self stringForPackageNames: package provides! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 17:59'!
providesString: aString 
	package provides: (self packageNamesFromString: aString).
	self changed: #providesString! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 18:05'!
returnTrue
	^true! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 8/26/2007 11:37'!
smidString
	^package squeakMapID
		ifNil: ['']
		ifNotNil: [package squeakMapID asString ]! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 8/26/2007 11:43'!
smidString: aStringOrText 
	| id str |
	str := aStringOrText asString withBlanksTrimmed.
	id := str isEmpty ifTrue: [nil] ifFalse: [UUID fromString: str].
	package squeakMapID: id.
	self changed: #smidString! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 17:58'!
stringForPackageNames: depends 
	| first |
	first := true.
	^String streamContents: 
			[:str | 
			depends do: 
					[:depName | 
					first ifTrue: [first := false] ifFalse: [str nextPutAll: ', '].
					str nextPutAll: depName]]! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 16:43'!
submit
	self acceptFields.
	whenComplete value: package! !

!UPackageEditor methodsFor: 'accessors' stamp: 'tfel 9/16/2009 00:22'!
urlString
	^package url ifNotNil: [ package url asString ]! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 10/25/2006 15:18'!
urlString: aString
	| url trimmedString |
	trimmedString := aString asString withBlanksTrimmed.
	url := (trimmedString isEmpty or: [ trimmedString beginsWith: '(' ])
		ifTrue: [ nil ]
		ifFalse: [ Url absoluteFromText: trimmedString ].
	package url: url.
	self changed: #urlString.
	^true! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:39'!
versionString
	^package version printString! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:39'!
versionString: aString
	package version: (UVersion readFromString: aString).
	self changed: #versionString.
	^true! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 17:12'!
window
	^window! !

Model subclass: #UUniverse
	instanceVariableNames: 'shortName description'
	classVariableNames: 'SystemUniverse'
	poolDictionaries: ''
	category: 'Universes-Model'!

!UUniverse commentStamp: 'ls 2/13/2005 11:10' prior: 0!
Abstract.  One "package universe".  A package universe is an evolving set of packages that multiple people can participate in.  Each Squeak image is a member of exactly one universe.
!

UUniverse subclass: #UCompoundUniverse
	instanceVariableNames: 'components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Model'!

!UCompoundUniverse commentStamp: 'ls 7/29/2004 18:48' prior: 0!
A universe that is the union of other universes.!

!UCompoundUniverse class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 18:47'!
composedOf: universes
	^self new
		components: universes;
		yourself! !

!UCompoundUniverse methodsFor: 'accessing' stamp: 'ls 2/13/2005 14:56'!
components: anObject
	components := anObject.
	components do: [ :c | c addDependent:  self ].! !

!UCompoundUniverse methodsFor: 'packages' stamp: 'ls 1/16/2005 14:09'!
packages
	^Array streamContents: [ :pstr |
		components do: [ :univ |
			pstr nextPutAll: univ packages ] ]! !

!UCompoundUniverse methodsFor: 'accessing' stamp: 'ls 7/29/2004 18:50'!
standardUniverses
	^Array streamContents: [ :str |
		components do: [ :comp |
			str nextPutAll: comp standardUniverses  ] ]! !

!UCompoundUniverse methodsFor: 'updating' stamp: 'ls 2/13/2005 14:57'!
update: aSymbol
	aSymbol = #packages ifTrue: [ self changed: #packages ].! !

!UCompoundUniverse methodsFor: 'packages' stamp: 'ls 2/13/2005 14:58'!
updatePackagesViaWWW
	components do: [ :component | component updatePackagesViaWWW ]! !

UUniverse subclass: #UStandardUniverse
	instanceVariableNames: 'serverName serverPort packagesURL packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Model'!

!UStandardUniverse commentStamp: 'ls 7/28/2004 10:36' prior: 0!
A universe that looks to one single server for authoritative information.
!

!UStandardUniverse methodsFor: 'packages' stamp: 'ls 2/13/2005 12:43'!
addPackage: aPackage
	"make sure that we end up with no two packages with the same name and version"
	packages removeAllSuchThat: [ :p | p name = aPackage name and: [ p version = aPackage version ] ].
	
	"now add the new package"
	packages add: aPackage.

	self changed: #packages! !

!UStandardUniverse methodsFor: 'initialize-release' stamp: 'ls 8/26/2007 11:57'!
initialize
	super initialize.
	shortName := 'silly'.
	serverName := 'localhost'.
	serverPort := 6770.
	packages := Set new.! !

!UStandardUniverse methodsFor: 'accessing' stamp: 'ls 1/16/2005 14:07'!
packages
	^packages! !

!UStandardUniverse methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 15:01'!
packages: aCollection
	packages := Set new.
	packages addAll: aCollection.
	self changed: #packages! !

!UStandardUniverse methodsFor: 'accessing' stamp: 'ls 2/13/2005 11:13'!
packagesURL
	"a URL from which the list of packages may be downloaded"
	^packagesURL! !

!UStandardUniverse methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 11:12'!
packagesURL: aURL
	packagesURL := aURL! !

!UStandardUniverse methodsFor: 'packages' stamp: 'ls 2/13/2005 12:43'!
removePackage: aPackage
	packages remove: aPackage.

	self changed: #packages! !

!UStandardUniverse methodsFor: 'accessing' stamp: 'ls 7/28/2004 13:21'!
serverName
	^serverName! !

!UStandardUniverse methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 10:37'!
serverName: aString	
	serverName := aString! !

!UStandardUniverse methodsFor: 'accessing' stamp: 'ls 7/28/2004 13:21'!
serverPort
	^serverPort! !

!UStandardUniverse methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 10:37'!
serverPort: port
	serverPort := port! !

!UStandardUniverse methodsFor: 'accessing' stamp: 'ls 7/29/2004 18:09'!
standardUniverses
	^{self}! !

!UStandardUniverse methodsFor: 'packages' stamp: 'ls 2/15/2005 22:42'!
updatePackagesViaWWW
	| rawPackageList newPackages |
	packagesURL ifNil: [ ^self ].
	rawPackageList := packagesURL retrieveContents content.
	(rawPackageList withBlanksTrimmed beginsWith: '<') ifFalse: [
		"it is possible that the universe is completely empty, but more likely there was an error retrieving the document"
		^self ].

	newPackages := UPackage decodePackagesFromXMLStream: (ReadStream on: rawPackageList).
	self packages: newPackages! !

!UUniverse class methodsFor: 'well known' stamp: 'ls 10/7/2007 13:36'!
betaUniverse 
	"[UUniverse switchSystemToUniverse: UUniverse betaUniverse]"
	^UStandardUniverse new
		serverName: 'universes.dnsalias.net';
		serverPort: UUniverseMultiServer defaultPort;
		shortName: 'beta';
		description: 'Beta Development';
		packagesURL: 'http://universes.dnsalias.net/~universes/repositories/beta.packages' asUrl;
		yourself
! !

!UUniverse class methodsFor: 'well known' stamp: 'ls 10/7/2007 13:40'!
betadevUniverse
	"a combination of normal plus beta packages"
	"[UUniverse switchSystemToUniverse: UUniverse betadevUniverse]"
	^UCompoundUniverse composedOf: {
		self developmentUniverse.
		self betaUniverse
	}! !

!UUniverse class methodsFor: 'well known' stamp: 'ls 3/22/2007 11:34'!
developmentUniverse 
	"[UUniverse switchSystemToUniverse: UUniverse developmentUniverse]"
	^UStandardUniverse new
		serverName: 'universes.dnsalias.net';
		serverPort: UUniverseMultiServer defaultPort;
		shortName: 'development';
		description: 'Development';
		packagesURL: 'http://universes.dnsalias.net/~universes/repositories/development.packages' asUrl;
		yourself
! !

!UUniverse class methodsFor: 'well known' stamp: 'ls 2/13/2005 12:45'!
exampleCompoundUniverse
	"[UUniverse switchSystemToUniverse: UUniverse exampleCompoundUniverse]"
	^(UCompoundUniverse composedOf: {
		self developmentUniverse.
		self homeMoviesUniverse
	}) description: 'example compound universe'; yourself! !

!UUniverse class methodsFor: 'well known' stamp: 'ls 3/22/2007 13:22'!
homeMoviesUniverse 
	"[UUniverse switchSystemToUniverse: UUniverse homeMoviesUniverse]"
	^UStandardUniverse new
		shortName: 'homemovies';
		serverName: 'universes.dnsalias.net';
		serverPort: UUniverseMultiServer defaultPort;
		packagesURL: 'http://universes.dnsalias.net/~universes/repositories/homemovies.packages' asUrl;
		description: 'Home Movies';
		yourself! !

!UUniverse class methodsFor: 'class initialization' stamp: 'ls 2/15/2005 23:42'!
initialize
	"fix up old instances, to have a proper packagesURL"
	"this method should be deleted, after suitable time has passed to allow for upgrades"

	self allSubInstancesDo: [ :universe |
		universe class == UStandardUniverse ifTrue: [
			universe packagesURL == nil ifTrue: [
				"no URL specified.  guess...."
				universe serverPort = 4129 ifTrue: [
					universe shortName: 'development'.
					universe packagesURL: 'http://universes.dnsalias.net:8888/~universes/repositories/development.packages' asUrl.
					universe serverPort: UUniverseMultiServer defaultPort. ].
				universe serverPort = 8940 ifTrue: [ 
					universe shortName: 'homevideos'.
					universe packagesURL: 'http://universes.dnsalias.net:8888/~universes/repositories/homemovies.packages' asUrl.
					universe serverPort: UUniverseMultiServer defaultPort. ].
				universe serverPort = 7273 ifTrue: [ 
					universe shortName: 'squeak37'.
					universe packagesURL: 'http://universes.dnsalias.net:8888/~universes/repositories/squeak37.packages' asUrl.
					universe serverPort: UUniverseMultiServer defaultPort. ]. ] ] ]! !

!UUniverse class methodsFor: 'well known' stamp: 'ls 10/7/2007 14:05'!
squeak310Universe 
	"[UUniverse switchSystemToUniverse: UUniverse squeak310Universe]"
	^UStandardUniverse new
		serverName: 'universes.dnsalias.net';
		serverPort: UUniverseMultiServer defaultPort;
		shortName: 'squeak3.10';
		description: 'Squeak 3.10';
		packagesURL: 'http://universes.dnsalias.net/~universes/repositories/squeak3.10.packages' asUrl;
		yourself! !

!UUniverse class methodsFor: 'well known' stamp: 'ls 3/22/2007 13:22'!
squeak37Universe 
	"[UUniverse switchSystemToUniverse: UUniverse squeak37Universe]"
	^UStandardUniverse new
		serverName: 'universes.dnsalias.net';
		serverPort: UUniverseMultiServer defaultPort;
		shortName: 'squeak37';
		description: 'Squeak 3.7';
		packagesURL: 'http://universes.dnsalias.net/~universes/repositories/squeak37.packages' asUrl;
		yourself! !

!UUniverse class methodsFor: 'well known' stamp: 'ls 3/22/2007 11:34'!
squeak39Universe 
	"[UUniverse switchSystemToUniverse: UUniverse squeak39Universe]"
	^UStandardUniverse new
		serverName: 'universes.dnsalias.net';
		serverPort: UUniverseMultiServer defaultPort;
		shortName: 'squeak3.9';
		description: 'Squeak 3.9';
		packagesURL: 'http://universes.dnsalias.net/~universes/repositories/squeak3.9.packages' asUrl;
		yourself! !

!UUniverse class methodsFor: 'system' stamp: 'ls 7/29/2004 18:54'!
switchSystemToUniverse: aUniverse
	SystemUniverse := aUniverse! !

!UUniverse class methodsFor: 'system' stamp: 'ls 2/13/2005 12:44'!
systemUniverse
	"return the universe this image uses"
	^SystemUniverse ifNil: [ SystemUniverse := self developmentUniverse ]! !

!UUniverse methodsFor: 'packages' stamp: 'ls 7/29/2004 19:09'!
addPackages: newPackages
	newPackages do: [ :p | self addPackage: p ]! !

!UUniverse methodsFor: 'packages' stamp: 'tonyg 2/24/2005 20:14'!
buildPackageCache
	self packages do: [ :p | p cachedCopyFilename ].! !

!UUniverse methodsFor: 'accessing' stamp: 'ls 2/13/2005 11:10'!
description
	"The description is a one-line description of the universe for human consumption."

	^description! !

!UUniverse methodsFor: 'initialize-release' stamp: 'ls 7/29/2004 16:16'!
description: aString
	description := aString! !

!UUniverse methodsFor: 'packages' stamp: 'ls 1/16/2005 14:06'!
hasPackageNamed: name
	^self packages anySatisfy: [ :p | p name = name ].
	! !

!UUniverse methodsFor: 'initialize-release' stamp: 'ls 1/16/2005 14:07'!
initialize
	description := 'some universe'.! !

!UUniverse methodsFor: 'packages' stamp: 'ls 7/28/2004 17:17'!
newestPackageNamed: name
	| potentials sorted |
	potentials := self packagesNamed: name.
	sorted := potentials asSortedCollection: [ :p1 :p2 | p1 version < p2 version ].
	^sorted last! !

!UUniverse methodsFor: 'packages' stamp: 'ls 1/16/2005 14:06'!
packageNames
	| names |
	names := Set new.
	self packages do: [ :p | names add: p name ].
	^names! !

!UUniverse methodsFor: 'packages' stamp: 'ls 1/16/2005 14:08'!
packages
	^self subclassResponsibility! !

!UUniverse methodsFor: 'packages' stamp: 'ls 1/16/2005 14:07'!
packagesNamed: name
	^self packages select: [ :p | p name = name ].
	! !

!UUniverse methodsFor: 'packages' stamp: 'ls 1/16/2005 14:06'!
removePackageNamed: packageName withVersion: version
	| packagesToRemove |
	packagesToRemove := self packages select: [ :p | p name = packageName and: [ p version = version ] ].
	packagesToRemove do: [ :p | self removePackage: p ].
	! !

!UUniverse methodsFor: 'accessing' stamp: 'ls 2/13/2005 14:46'!
shortName
	"A short, computer-friendly alphanumeric identifier"

	^shortName! !

!UUniverse methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 11:10'!
shortName: aString
	shortName := aString
! !

!UUniverse methodsFor: 'accessing' stamp: 'ls 2/15/2005 21:49'!
standardUniverses
	"return a list of standard universes within the receiver.  See class UStandardUniverse"
	^self subclassResponsibility! !

!UUniverse methodsFor: 'packages' stamp: 'ls 2/13/2005 14:56'!
updatePackagesViaWWW
	"update the packages in this universe by downloading them from the universe's URL"
	^self subclassResponsibility! !

Model subclass: #UUniverseBrowser
	instanceVariableNames: 'universe configuration selectedPackage packagesToInstall installSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Browser'!

!UUniverseBrowser commentStamp: '<historical>' prior: 0!
A tool to support one-click installs and upgrades of packages within a universe.!

!UUniverseBrowser class methodsFor: 'instance creation' stamp: 'ls 2/13/2005 14:53'!
forUniverse: aUniverse
	^self new universe: aUniverse; yourself! !

!UUniverseBrowser class methodsFor: 'class initialization' stamp: 'mt 5/10/2015 12:39'!
initialize
	#('Package Browser (basic)' 'Universe Browser' 'Package Universe Browser') do: [:oldName |
		TheWorldMenu unregisterOpenCommand: oldName ].
	
	"TheWorldMenu registerOpenCommand: {'Universe Browser (basic)'. {self. #open}}.
	Preferences setWindowColorFor: self name to: (Color r: 0.194 g: 0.645 b: 1.0)."! !

!UUniverseBrowser class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 18:15'!
open
	^self new open! !

!UUniverseBrowser class methodsFor: 'dependencies' stamp: 'ls 7/29/2004 15:16'!
orderPackagesByDependency: packages
	"return a collection of the specified packages such that, when possible, any dependencies of a package are ordered before that package"
	"The present algorithm is simple but slow..."
	| remainingPackages orderedPackages packagesToAdd |
	remainingPackages := Set new.
	orderedPackages := OrderedCollection new.
	remainingPackages addAll: packages.
	
	"each time through this loop, add to orderedPackages any packages whose dependencies are not in remainaingPackages"
	[	packagesToAdd := remainingPackages select: [ :p | p depends noneSatisfy: [ :depName | remainingPackages anySatisfy: [ :p2 | p2 name = depName ] ] ].
		packagesToAdd isEmpty not
	] whileTrue: [
		orderedPackages addAll: packagesToAdd.
		remainingPackages := remainingPackages difference: packagesToAdd ].
	
	orderedPackages addAll: remainingPackages.
	^orderedPackages
! !

!UUniverseBrowser class methodsFor: 'class initialization' stamp: 'mt 5/10/2015 12:38'!
unload

	#('Package Browser (basic)' 'Universe Browser' 'Package Universe Browser') do: [:oldName |
		TheWorldMenu unregisterOpenCommand: oldName ].! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 11/26/2006 12:56'!
anyPackageSelected
	^ selectedPackage notNil! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 8/14/2007 21:16'!
anyPackagesToInstall
	^self installSet anyPackageSelected ! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 8/14/2007 21:26'!
canMarkSelectionForInstallation
	^self anyPackageSelected and: [ 
		(self installSet isPackageVersionSelected: self selectedPackage) not and: [
			(self installSet isPackageVersionInstalled: self selectedPackage) not ]]! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'nice 8/19/2010 16:36'!
categories
	^(self sortedPackages collect: [ :p | p category])
		asSet asArray sort: [ :p1 :p2 | p1 asString < p2 asString]! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 11/26/2006 12:35'!
categoriesAndPackagesIn: categoryPrefix
	| categories packages |
	categories := self categories select: [ :cat | cat isSubcategoryOf: categoryPrefix ].
	packages := self sortedPackages select: [ :p | p category = categoryPrefix ].
	^categories, packages! !

!UUniverseBrowser methodsFor: 'install selections' stamp: 'ls 8/14/2007 21:10'!
chooseUpgrades
	"select packages that appear to be upgrades of packages that are already installed"
	self installSet selectAllUpgrades.
	
	self changed: #packageDescriptions.
	self changed: #rootCategoriesAndPackages.
! !

!UUniverseBrowser methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:58'!
configuration: aConfiguration
	configuration := aConfiguration! !

!UUniverseBrowser methodsFor: 'install selections' stamp: 'ls 8/14/2007 21:13'!
doInstall
	self installSet anyPackageSelected ifFalse: [
		^self inform: 'no packages selected to install' ].

	self installSet doInstall.	
	
	self changed: #packageDescriptions.
	self changed: #rootCategoriesAndPackages.
! !

!UUniverseBrowser methodsFor: 'initialize-release' stamp: 'ls 8/14/2007 21:18'!
initialize
	configuration := UConfiguration forSystem.
	self universe: UUniverse systemUniverse! !

!UUniverseBrowser methodsFor: 'install selections' stamp: 'ls 8/14/2007 21:30'!
installSelectedPackage
	self anyPackageSelected ifFalse: [ ^self ].
	self installSet planToInstallPackage: self selectedPackage.
		
	self changed: #packageDescriptions.
	self changed: #rootCategoriesAndPackages.
! !

!UUniverseBrowser methodsFor: 'install selections' stamp: 'ls 8/14/2007 21:06'!
installSet
	^installSet ifNil: [ installSet :=
		UGlobalInstaller universe: universe configuration: configuration
	]! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 11/26/2006 12:34'!
isCategory: anObject
	^anObject isUPackageCategory! !

!UUniverseBrowser methodsFor: 'user interface' stamp: 'ls 9/4/2004 14:37'!
makeButtonWithAction: selector andGetState: getStateSelector andLabel: aString
	^(PluggableButtonMorph on: self getState: getStateSelector action: selector)
		label: aString;
		useRoundedCorners;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		onColor: self defaultBackgroundColor offColor: self defaultBackgroundColor muchLighter;
		yourself! !

!UUniverseBrowser methodsFor: 'user interface' stamp: 'ls 9/4/2004 14:35'!
makeButtonWithAction: selector  andLabel: aString
	^self makeButtonWithAction: selector andGetState: #returnTrue andLabel: aString! !

!UUniverseBrowser methodsFor: 'user interface' stamp: 'ls 11/26/2006 12:50'!
morphicView
	| win packageList installButton doInstallButton buttonList upgradeButton updateListButton descriptionArea installButtonHolder |
	win := SystemWindow labelled: 'Universe'.
	win model: self.
		
	packageList := 
		PluggableTreeMorph new
			model:  self;
			name: 'package list';
			getRootsSelector: #rootCategoriesAndPackages; 
			hasChildrenSelector: #isCategory:; 
			getChildrenSelector: #categoriesAndPackagesIn:;
			setSelectedSelector: #selectPackageOrCategory:;
			getLabelSelector: #packageOneLineDescription:.
	win addMorph: packageList frame: ((0@0) extent: (0.5@0.9)).
	
	installButtonHolder := Morph new.  "necessary to keep SystemWindow from screwing up the colors of the button"
	installButtonHolder 
		name: 'holder for install button';
		layoutPolicy: TableLayout new;
		borderColor: self defaultBackgroundColor.
	doInstallButton := self makeButtonWithAction: #doInstall andGetState: #anyPackagesToInstall andLabel: 'Install Selections'.
	doInstallButton
		useSquareCorners;
		borderWidth: 0;
		setBalloonText: 'Download and install all the packages that you have selected';
		name: 'install selections button'.
	installButtonHolder addMorph: doInstallButton.
	win addMorph: installButtonHolder frame: ((0@0.9) extent:(1@0.1)).

	descriptionArea := PluggableTextMorph on: self text: #selectedPackageDescription accept: nil.
	win addMorph: descriptionArea frame: ((0.5@0.4) extent: (0.5@0.5)).
	
	buttonList := AlignmentMorph newColumn.
	buttonList
		cellInset: 0@3;
		name: 'button list'.
	win addMorph: buttonList frame: ((0.5@0) extent: (0.5@0.4)).
		
	installButton := self makeButtonWithAction: #installSelectedPackage andGetState: #canMarkSelectionForInstallation andLabel: 'select package'.
	installButton setBalloonText: 'Select this package for installation'.
	buttonList addMorph: installButton.
	
	upgradeButton := self makeButtonWithAction: #chooseUpgrades andLabel: 'select all upgrades'.
	upgradeButton setBalloonText: 'Select every possible upgrade for the currently installed packages'.
	buttonList addMorphBack: upgradeButton.
	
	updateListButton := self makeButtonWithAction: #requestPackageList andLabel: 'update list from network'.
	updateListButton setBalloonText: 'Refresh the list of available packages from the network'.
	buttonList addMorphBack: updateListButton.
	
	^win! !

!UUniverseBrowser methodsFor: 'user interface' stamp: 'ls 7/29/2004 16:19'!
open
	self morphicView openInWorld! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 11/26/2006 12:48'!
packageDescriptions
	^ self sortedPackages collect: [:p | self packageOneLineDescription: p]! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 8/26/2007 12:25'!
packageOneLineDescription: p 
	| commentary |
	p isUPackage ifFalse: [ ^p printString ].
	commentary := ''.
	(self installSet isPackageVersionSelected: p) ifTrue: [commentary := '(to install) '].
	(configuration includesPackageSpec: p packageSpec) 
		ifTrue: [commentary := '(installed) '].
	^ commentary , p printString
! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 8/14/2007 21:21'!
packagesChanged
	self installSet initializeSelectedPackageVersions.  "the selected packages may not be there any more!!"
	self selectPackageOrCategory:   nil.
	
	self changed: #packageDescriptions.  self flag: #lex.  "only for compatibility with old, open GUI windows"
	self changed: #rootCategoriesAndPackages.
	! !

!UUniverseBrowser methodsFor: 'server communication' stamp: 'nice 6/18/2013 22:31'!
requestPackageList
	UIManager default informUser: 'updating package list...' during:  [
		universe updatePackagesViaWWW ]
! !

!UUniverseBrowser methodsFor: 'user interface' stamp: 'ls 9/4/2004 14:35'!
returnTrue
	"return true; used for buttons that are always enabled"
	^true! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 11/26/2006 12:24'!
rootCategoriesAndPackages
	^self categoriesAndPackagesIn: (UPackageCategory root)! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 12/31/2006 16:13'!
selectPackageOrCategory: packageOrCategory
	selectedPackage := 
		packageOrCategory isUPackage
			ifTrue: [ packageOrCategory ]
			ifFalse: [ nil ].
	self changed: #selectedPackage.
	self changed: #selectedPackageDescription.
	self changed: #canMarkSelectionForInstallation.

	! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 11/26/2006 12:55'!
selectedPackage
	^selectedPackage! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'dc 3/22/2007 14:22'!
selectedPackageDescription
	self anyPackageSelected ifFalse: [ ^ '' ].
	^ self selectedPackage longDescription 
	! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 11/26/2006 12:58'!
selectedPackageIndex
	self flag: #lex.  "only present in case people have existing browser windows open"
	^self sortedPackages indexOf: selectedPackage! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 11/26/2006 13:02'!
selectedPackageIndex: anIndex
	self flag: #lex.  "only present in case people have existing browser windows open"
	self selectPackageOrCategory:
		(anIndex = 0 ifTrue: [ nil ] ifFalse: [ self sortedPackages at: anIndex ]).
	self changed: #selectedPackageIndex
	! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 12/31/2006 16:25'!
sortedPackages
	| packages |
	packages := Set new.
	packages addAll: universe packages.
	packages addAll: configuration installedPackages.
	
	^packages asSortedCollection: [ :p1 :p2 |
		p1 name < p2 name or: [
			p1 name = p2 name and: [ p1 version < p2 version ] ] ].
	! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 11/26/2006 12:19'!
subcategoriesOf: categoryPrefix
	^self categories select: [ :cat | cat isSubcategoryOf: categoryPrefix ]! !

!UUniverseBrowser methodsFor: 'user interface' stamp: 'ls 11/26/2006 13:04'!
titleAreaText
	self flag: #lex.  "this is only present to support browser windows that are already open"
	^universe shortName! !

!UUniverseBrowser methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 15:12'!
universe: aUniverse
	universe := aUniverse.
	universe addDependent: self.! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 2/13/2005 15:12'!
update: aSymbol
	aSymbol = #packages ifTrue: [ self packagesChanged ]! !

!String methodsFor: '*Universes' stamp: 'ls 8/26/2007 09:16'!
asUVersion
	^UVersion readFromString: self! !

!String methodsFor: '*universes-model' stamp: 'ls 7/27/2004 17:32'!
uversionEqual: anObject
	^anObject isString and: [ self = anObject ]! !

!String methodsFor: '*universes-model' stamp: 'ls 7/27/2004 21:13'!
uversionLessThan: anObject
	^anObject isInteger or: [ self < anObject ]! !

!Object methodsFor: '*universes' stamp: 'ls 11/26/2006 12:33'!
isUPackage
	^false! !

!Object methodsFor: '*universes' stamp: 'ls 11/26/2006 12:33'!
isUPackageCategory
	^false! !

Object subclass: #UAccount
	instanceVariableNames: 'username password email packageNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Policy'!

!UAccount commentStamp: '<historical>' prior: 0!
An account as used in the standard UPolicy's.!

!UAccount methodsFor: 'packages' stamp: 'ls 7/28/2004 18:03'!
addPackageName: name
	packageNames add: name! !

!UAccount methodsFor: 'accessing' stamp: 'ls 7/28/2004 21:47'!
email: aString
	email := aString! !

!UAccount methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 18:02'!
initialize
	username := 'joeblow'.
	password := ''.
	packageNames := Set new.! !

!UAccount methodsFor: 'packages' stamp: 'ls 7/28/2004 18:03'!
ownsPackageName: name
	^packageNames includes: name! !

!UAccount methodsFor: 'accessing' stamp: 'ls 7/28/2004 21:50'!
password
	^password! !

!UAccount methodsFor: 'accessing' stamp: 'ls 7/28/2004 21:47'!
password: anObject
	password := anObject! !

!UAccount methodsFor: 'printing' stamp: 'ls 2/15/2005 23:44'!
printOn: aStream
	aStream nextPutAll: 'Account: ', username! !

!UAccount methodsFor: 'accessing' stamp: 'ls 7/28/2004 21:50'!
username
	^username! !

!UAccount methodsFor: 'accessing' stamp: 'ls 7/28/2004 21:47'!
username: anObject
	username := anObject! !

Object subclass: #UConfiguration
	instanceVariableNames: 'installedPackages'
	classVariableNames: 'SystemConfiguration'
	poolDictionaries: ''
	category: 'Universes-Model'!

!UConfiguration commentStamp: '<historical>' prior: 0!
One configuration of packages.!

!UConfiguration class methodsFor: 'system' stamp: 'ls 7/27/2004 21:57'!
forSystem
	"return a configuration describing the currently running system"
	^SystemConfiguration ifNil: [ SystemConfiguration := self new ].
	! !

!UConfiguration methodsFor: 'packages' stamp: 'ls 7/28/2004 10:19'!
includesPackageNamed: name
	^self installedPackages anySatisfy: [ :p | p name = name ]! !

!UConfiguration methodsFor: 'packages' stamp: 'ls 8/26/2007 12:25'!
includesPackageSpec: packageSpec
	^self installedPackages anySatisfy: [ :p | p packageSpec = packageSpec ]! !

!UConfiguration methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:55'!
initialize
	installedPackages := Set new.! !

!UConfiguration methodsFor: 'installing' stamp: 'ls 7/27/2004 21:55'!
installPackage: aPackage
	| matchingPackages |
	matchingPackages := installedPackages select: [ :p | p name = aPackage name ].
	installedPackages removeAll: matchingPackages.
	aPackage install.
	installedPackages add: aPackage.
	! !

!UConfiguration methodsFor: 'packages' stamp: 'ls 7/27/2004 22:02'!
installedPackages
	^installedPackages! !

!UConfiguration methodsFor: 'packages' stamp: 'ls 7/28/2004 10:18'!
packageNamed: name
	^self installedPackages detect: [ :p | p name = name ]! !

Object subclass: #UGlobalInstaller
	instanceVariableNames: 'configuration selectedPackageVersions universe'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Model'!

!UGlobalInstaller commentStamp: 'dc 7/24/2007 11:43' prior: 0!
I'm used by universe browsers to keep track of the configuration, the universe, the selected packages... I provide features to install new packages, to upgrade the system...!

!UGlobalInstaller class methodsFor: 'instance-creation' stamp: 'dc 4/19/2007 14:11'!
universe: aUniverse
	^ self universe: aUniverse configuration: UConfiguration forSystem ! !

!UGlobalInstaller class methodsFor: 'instance-creation' stamp: 'dc 4/19/2007 14:12'!
universe: aUniverse configuration: aConfiguration
	^ self new
		universe: aUniverse;
		configuration: aConfiguration;
		yourself! !

!UGlobalInstaller methodsFor: 'accessing dynamic' stamp: 'dc 4/19/2007 14:30'!
allCategories
	^ (universe packages collect: [:package | package category])
			asSet
			asSortedCollection: [:cat1 :cat2 | cat1 asString < cat2 asString]! !

!UGlobalInstaller methodsFor: 'accessing dynamic' stamp: 'dc 4/19/2007 14:38'!
allPackages
	^ universe packageNames asSortedCollection.! !

!UGlobalInstaller methodsFor: 'private - package selection' stamp: 'dc 4/21/2007 12:25'!
allPackagesNeededToInstall: initialPackage  orIfImpossible: errorBlock
	"find all packages needed to installed initialPackage; if it is impossible to accomplish, invoke errorBlock with the name of the missing package"
	| newPackages packagesToConsider |
	newPackages := Set new.
	packagesToConsider := OrderedCollection with: initialPackage.
	[ packagesToConsider isEmpty ]
		whileFalse: [| package |
			package := packagesToConsider removeFirst.
			(newPackages includes: package) ifFalse: [
			newPackages add: package.
			package depends do: [ :depName |
				((configuration includesPackageNamed: depName) not and: [ selectedPackageVersions noneSatisfy: [ :p | p name = depName  ] ])
				ifTrue: [
					"the dependency is needed but is not installed or planned to be installed"
					(universe hasPackageNamed: depName) ifTrue: [
						"in principle, one could additionally consider trying a different package than the newest..."
						packagesToConsider add: (universe newestPackageNamed: depName) ]
					ifFalse: [
						^errorBlock value: depName ] ] ] ] ].
	
	^newPackages! !

!UGlobalInstaller methodsFor: 'accessing dynamic' stamp: 'dc 4/22/2007 12:27'!
allPossibleUpgrades
	^ universe packageNames
		inject: OrderedCollection new
		into: [ :upgrades :name |
			(configuration includesPackageNamed: name)
			ifTrue: [| cpack mypack |
				cpack := configuration packageNamed: name.
				mypack := universe newestPackageNamed: name.
				(mypack version > cpack version)
					ifTrue: [upgrades add: mypack]].
				
				upgrades].! !

!UGlobalInstaller methodsFor: 'testing' stamp: 'dc 4/21/2007 12:43'!
anyPackageSelected
	^ selectedPackageVersions notEmpty! !

!UGlobalInstaller methodsFor: 'private' stamp: 'dc 4/19/2007 14:13'!
configuration: aConfiguration 
	configuration := aConfiguration! !

!UGlobalInstaller methodsFor: 'testing' stamp: 'dc 4/22/2007 12:23'!
containsAnyUpgrade
	^ self allPossibleUpgrades notEmpty ! !

!UGlobalInstaller methodsFor: 'actions' stamp: 'dc 4/22/2007 12:51'!
deselectPackageNamed: aPackageName
	self selectedPackageVersions 
		removeAllSuchThat: [:package | package name = aPackageName ]! !

!UGlobalInstaller methodsFor: 'actions' stamp: 'dc 4/22/2007 12:47'!
deselectPackageVersion: aPackageVersion
	self selectedPackageVersions 
		remove: aPackageVersion  ifAbsent: nil! !

!UGlobalInstaller methodsFor: 'actions' stamp: 'nice 6/18/2013 22:30'!
doInstall
	| orderedPackages |
	self anyPackageSelected not ifTrue: [^self].
	orderedPackages := self orderPackagesByDependency: selectedPackageVersions.
	orderedPackages
		do: [ :p | 
				UIManager default informUser: 'installing ', p printString
						during: [configuration installPackage: p] ].
	self initializeSelectedPackageVersions.
! !

!UGlobalInstaller methodsFor: 'initialize-release' stamp: 'dc 4/21/2007 13:12'!
initialize
	super initialize.
	self initializeSelectedPackageVersions! !

!UGlobalInstaller methodsFor: 'initialize-release' stamp: 'dc 4/21/2007 13:12'!
initializeSelectedPackageVersions
	selectedPackageVersions := Set new! !

!UGlobalInstaller methodsFor: 'accessing dynamic' stamp: 'dc 4/19/2007 14:39'!
installedPackageVersions
	^ configuration installedPackages 
		asSortedCollection: [:p1 :p2 | p1 name < p2 name].! !

!UGlobalInstaller methodsFor: 'testing' stamp: 'dc 4/19/2007 17:30'!
isPackageInstalled: aPackage
	^ self installedPackageVersions anySatisfy: [:packageVersion | packageVersion name =  aPackage]! !

!UGlobalInstaller methodsFor: 'testing' stamp: 'dc 4/19/2007 17:05'!
isPackageSelected: aPackageName
	^ self selectedPackageVersions
		anySatisfy: [:packageVersion | packageVersion name = aPackageName ]! !

!UGlobalInstaller methodsFor: 'testing' stamp: 'dc 4/19/2007 17:29'!
isPackageVersionInstalled: aPackageVersion
	^ self installedPackageVersions includes: aPackageVersion! !

!UGlobalInstaller methodsFor: 'testing' stamp: 'dc 5/28/2007 11:27'!
isPackageVersionSelected: aPackageVersion
	^ selectedPackageVersions includes: aPackageVersion! !

!UGlobalInstaller methodsFor: 'private - package selection' stamp: 'dc 4/21/2007 13:13'!
orderPackagesByDependency: packages
	"return a collection of the specified packages such that, when possible, any dependencies of a package are ordered before that package"
	"The present algorithm is simple but slow..."
	| remainingPackages orderedPackages packagesToAdd |
	remainingPackages := Set new.
	orderedPackages := OrderedCollection new.
	remainingPackages addAll: packages.
	
	"each time through this loop, add to orderedPackages any packages whose dependencies are not in remainaingPackages"
	[	packagesToAdd := remainingPackages select: [ :p | p depends noneSatisfy: [ :depName | remainingPackages anySatisfy: [ :p2 | p2 name = depName ] ] ].
		packagesToAdd isEmpty not
	] whileTrue: [
		orderedPackages addAll: packagesToAdd.
		remainingPackages := remainingPackages difference: packagesToAdd ].
	
	orderedPackages addAll: remainingPackages.
	^ orderedPackages
! !

!UGlobalInstaller methodsFor: 'accessing dynamic' stamp: 'dc 4/19/2007 14:36'!
packageVersionsForPackage: aPackageName
	^ (universe packages
		select: [:package | package name = aPackageName])
		asSortedCollection: [:p1 :p2 | p1 version < p2 version].
	! !

!UGlobalInstaller methodsFor: 'accessing dynamic' stamp: 'dc 4/19/2007 14:37'!
packagesForCategory: aCategory
	^ (universe packages
		select: [:package | package category = aCategory]
		thenCollect: [:package | package name])
		asSortedCollection ! !

!UGlobalInstaller methodsFor: 'actions' stamp: 'dc 4/21/2007 12:20'!
planToInstallPackage: initialPackage
	"plan to install a package plus its dependencies; refuses if any dependencies cannot be met"
	| newPackages |
	"find all packages needed to install this one"
	newPackages := self allPackagesNeededToInstall: initialPackage
						orIfImpossible: [ :missingDep |
								^self notify: 'could not find necessary package: ', missingDep ].
	
	selectedPackageVersions removeAllSuchThat: [ :p | p name = initialPackage name ].
	newPackages do: [ :p | selectedPackageVersions add: p ].! !

!UGlobalInstaller methodsFor: 'actions' stamp: 'dc 4/22/2007 12:54'!
planToInstallPackageNamed: aPackageName
	self planToInstallPackage: (universe newestPackageNamed: aPackageName)! !

!UGlobalInstaller methodsFor: 'actions' stamp: 'nice 6/18/2013 22:31'!
requestPackageList
	UIManager default informUser: 'updating package list...' during:  [
		universe updatePackagesViaWWW ]
! !

!UGlobalInstaller methodsFor: 'actions' stamp: 'dc 4/22/2007 12:27'!
selectAllUpgrades
	"select packages that appear to be upgrades of packages that are already installed"

	self allPossibleUpgrades 
		do: [:package | self planToInstallPackage: package]! !

!UGlobalInstaller methodsFor: 'accessing' stamp: 'dc 4/21/2007 12:41'!
selectedPackageVersions
	^ selectedPackageVersions! !

!UGlobalInstaller methodsFor: 'accessing' stamp: 'ls 6/3/2007 10:34'!
universe
	^universe! !

!UGlobalInstaller methodsFor: 'private' stamp: 'dc 4/19/2007 14:13'!
universe: aUniverse 
	universe := aUniverse! !

Object subclass: #UInterfaceUtilities
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Interface'!

!UInterfaceUtilities commentStamp: 'ls 2/13/2005 17:22' prior: 0!
This class holds miscellaneous bits of code used to build user interfaces in the various Universes tools.
!

!UInterfaceUtilities class methodsFor: 'as yet unclassified' stamp: 'ls 2/13/2005 17:37'!
makeButtonWithAction: selector andGetState: getStateSelector andLabel: aString for: model
	^(PluggableButtonMorph on: model getState: getStateSelector action: selector)
		label: aString;
		useRoundedCorners;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		onColor: model defaultBackgroundColor offColor: model defaultBackgroundColor muchLighter;
		yourself! !

!UInterfaceUtilities class methodsFor: 'as yet unclassified' stamp: 'ls 2/13/2005 17:41'!
makeButtonWithAction: selector  andLabel: aString for: model
	^self makeButtonWithAction: selector andGetState: #returnTrue  andLabel: aString	for: model! !

!UInterfaceUtilities class methodsFor: 'as yet unclassified' stamp: 'ls 2/13/2005 17:34'!
makeFieldGet: getSelector  set: setSelector  for: model
	| field fieldHeight |
	fieldHeight := TextStyle default defaultFont pointSize + 8.
		
		
	field := PluggableTextMorph on: model text: getSelector accept: setSelector.
	field height: fieldHeight.
	field hResizing: #spaceFill.
	field hideScrollBarsIndefinitely.
	field setProperty: #alwaysAccept toValue: true.

	model noteField: field.

	^field! !

!UInterfaceUtilities class methodsFor: 'as yet unclassified' stamp: 'ls 2/13/2005 17:42'!
makeFieldRowNamed: fieldName  getSelector: getSelector setSelector: setSelector for: model
	^self makeFieldRowNamed: fieldName  getSelector: getSelector setSelector: setSelector isPassword: false for: model! !

!UInterfaceUtilities class methodsFor: 'as yet unclassified' stamp: 'ls 2/13/2005 17:36'!
makeFieldRowNamed: fieldName  getSelector: getSelector setSelector: setSelector isPassword: isPassword for: model
	| row field |
	row := AlignmentMorph newRow.
	row color: Color transparent.
	row cellInset: 3@0.
	
	field := self makeFieldGet: getSelector set: setSelector for: model.
	isPassword ifTrue:[
		field font: (StrikeFont passwordFontSize: TextStyle default defaultFont pointSize) ].

	row addMorph: (StringMorph contents: fieldName).
	row addMorphBack: field.

	^row

! !

Object subclass: #UMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMessage commentStamp: '<historical>' prior: 0!
A message that can be sent to or from a UServer.  All instances may be converted to an array of strings, and that array of strings may be parsed back with fromStringArray:.!

UMessage subclass: #UMAddAccount
	instanceVariableNames: 'username password email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMAddAccount commentStamp: '<historical>' prior: 0!
A request to add a user account.
!

!UMAddAccount class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:34'!
fromStringArray: stringArray
	^self username: stringArray second password: stringArray third email: stringArray fourth! !

!UMAddAccount class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:34'!
username: username  password: password  email: email
	^self basicNew username: username  password: password  email: email! !

!UMAddAccount methodsFor: '*universes-server' stamp: 'ls 7/28/2004 21:46'!
applyToServer: server forConnection: connection
	server connection: connection requestedAccountWithUsername: username password: password email: email! !

!UMAddAccount methodsFor: 'converting' stamp: 'ls 7/28/2004 14:34'!
asStringArray
	^{'addaccount' . username . password . email}! !

!UMAddAccount methodsFor: 'logging' stamp: 'ls 5/28/2007 17:24'!
maybeLogMessage
	"Return a string for logging this message, if there is one"
	^'AddAccount ', username, ' ', email! !

!UMAddAccount methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:33'!
username: username0  password: password0  email: email0
	username := username0.
	password := password0.
	email := email0.
	! !

UMessage subclass: #UMAddPackage
	instanceVariableNames: 'username password package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMAddPackage class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 17:07'!
fromStringArray: array
	^self username: array second password: array third package: (UPackage decodeFromStringStream: (ReadStream on: (array allButFirst: 3)))! !

!UMAddPackage class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:37'!
username: username password: password package: package
	^self basicNew username: username password: password package: package! !

!UMAddPackage methodsFor: '*universes-server' stamp: 'ls 7/28/2004 17:03'!
applyToServer: server forConnection: connection
	server connection: connection requestedForUsername: username andPassword: password toAddPackage: package! !

!UMAddPackage methodsFor: 'converting' stamp: 'ls 7/28/2004 16:56'!
asStringArray
	^{'addpackage' . username . password },
	  package stringArrayEncoding! !

!UMAddPackage methodsFor: 'logging' stamp: 'ls 5/28/2007 17:43'!
maybeLogMessage
	"Return a string for logging this message, if there is one"
	^'AddPackage ', username, ' ', package name, '/', package version printString! !

!UMAddPackage methodsFor: 'printing' stamp: 'ls 1/13/2007 21:24'!
printOn: aStream
	aStream 
		print: self class;
		nextPutAll: ' (';
		print: package;
		nextPutAll: ')'! !

!UMAddPackage methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:37'!
username: username0 password: password0 package: package0
	username := username0.
	password := password0.
	package := package0.
	! !

UMessage subclass: #UMEditAccount
	instanceVariableNames: 'username password newPassword newEmail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMEditAccount commentStamp: '<historical>' prior: 0!
A request to change the password or email of an account.
!

!UMEditAccount class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:38'!
fromStringArray: array
	^self username: array second password: array third newPassword: array fourth newEmail: array fifth! !

!UMEditAccount class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:36'!
username: username  password: password  newPassword: newPassword newEmail: newEmail
	^self basicNew username: username  password: password  newPassword: newPassword newEmail: newEmail! !

!UMEditAccount methodsFor: '*universes-server' stamp: 'ls 7/28/2004 17:55'!
applyToServer: server forConnection: connection
	server connection: connection requestedAccountChangeForUsername: username password: password newPassword: newPassword newEmail: newEmail! !

!UMEditAccount methodsFor: 'converting' stamp: 'ls 7/28/2004 14:36'!
asStringArray
	^{'editaccount' . username . password . newPassword . newEmail}! !

!UMEditAccount methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:36'!
username: username0  password: password0  newPassword: newPassword0 newEmail: newEmail0
	username := username0.
	password := password0.
	newPassword := newPassword0.
	newEmail := newEmail0.
	! !

UMessage subclass: #UMEditedAccount
	instanceVariableNames: 'username newPassword newEmail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMEditedAccount commentStamp: '<historical>' prior: 0!
Notification that an account has been successfully edited.!

!UMEditedAccount class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 17:38'!
fromStringArray: array
	^self username: array second newPassword: array third newEmail: array fourth! !

!UMEditedAccount class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 17:37'!
username: username  newPassword: newPassword  newEmail: newEmail
	^self basicNew
		username: username  newPassword: newPassword  newEmail: newEmail;
		yourself! !

!UMEditedAccount methodsFor: '*universes-editor' stamp: 'ls 7/28/2004 17:59'!
applyToEditor: editor
	editor accountUpdatedWithUsername: username  password:  newPassword  email: newEmail! !

!UMEditedAccount methodsFor: 'converting' stamp: 'ls 7/28/2004 17:37'!
asStringArray
	^{'editedaccount' . username . newPassword . newEmail }! !

!UMEditedAccount methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 17:36'!
username: username0  newPassword: newPassword0  newEmail: newEmail0
	username := username0.
	newPassword := newPassword0.
	newEmail := newEmail0.
	! !

UMessage subclass: #UMError
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMError commentStamp: '<historical>' prior: 0!
An error message from the server to the client.!

UMError subclass: #UMConnectionFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMConnectionFailed commentStamp: '<historical>' prior: 0!
An error in establishing a connection to a server.!

!UMError class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 13:33'!
description: aString
	^self basicNew
		description: aString;
		yourself! !

!UMError class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 17:02'!
fromStringArray: array
	^self description: array second! !

!UMError methodsFor: '*universes-editor' stamp: 'ls 7/28/2004 21:58'!
applyToEditor: editor
	"the inform: is deferred, because otherwise the editor can stop stepping!!"
	WorldState addDeferredUIMessage: [ editor inform: 'Error: ', description ]
! !

!UMError methodsFor: '*universes-server' stamp: 'ls 7/28/2004 13:35'!
applyToServer: server forConnection: connection
	"if the client sends an error back, then the connection is really messed up"
	server destroyConnection: connection
	! !

!UMError methodsFor: 'converting' stamp: 'ls 7/28/2004 13:36'!
asStringArray
	^{'error' . description }! !

!UMError methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 13:26'!
description: aString
	description := aString! !

UMessage subclass: #UMMalformed
	instanceVariableNames: 'stringArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMMalformed commentStamp: '<historical>' prior: 0!
a malformed packet!

!UMMalformed class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 11:30'!
fromStringArray: array
	^self basicNew stringArray: array; yourself! !

!UMMalformed methodsFor: 'converting' stamp: 'ls 7/28/2004 11:31'!
asStringArray
	^self error: 'a malformed packet cannot be converted to a string array'! !

!UMMalformed methodsFor: 'accessing' stamp: 'ls 7/28/2004 11:45'!
stringArray: anObject
	stringArray := anObject! !

UMessage subclass: #UMPackageAdded
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMPackageAdded commentStamp: 'ls 7/28/2004 15:08' prior: 0!
A message declaring that a package has been added to the universe.
!

!UMPackageAdded class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 15:07'!
fromStringArray: array
	| str |
	str := ReadStream on: array.
	str next.
	^self package: (UPackage decodeFromStringStream: str)! !

!UMPackageAdded class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 15:07'!
package: aPackage
	^self basicNew
		package: aPackage;
		yourself! !

!UMPackageAdded methodsFor: '*universes-client' stamp: 'ls 7/30/2004 15:01'!
applyToClient: aClient
	aClient packageAdded: package! !

!UMPackageAdded methodsFor: '*universes-editor' stamp: 'ls 7/30/2004 15:38'!
applyToEditor: editor
	editor closeEditorForPackage: package.
! !

!UMPackageAdded methodsFor: 'converting' stamp: 'ls 7/28/2004 15:07'!
asStringArray
	^#('packageadded'), package stringArrayEncoding! !

!UMPackageAdded methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:59'!
package: aPackage
	package := aPackage! !

UMessage subclass: #UMPackageList
	instanceVariableNames: 'packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMPackageList commentStamp: '<historical>' prior: 0!
A message describing a list of packages that are in the server's universe.!

!UMPackageList class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 15:05'!
fromStringArray: array
	| str packages numPackages |
	str := ReadStream on: array.
	str next.  "skip the 'packages' designation".

	packages := OrderedCollection new.

	numPackages := Integer readFromString: str next.
	numPackages timesRepeat: [
		packages add: (UPackage decodeFromStringStream: str) ].
		
	^self packages: packages! !

!UMPackageList class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 12:01'!
packages: aCollection
	^self basicNew
		packages: aCollection;
		yourself! !

!UMPackageList methodsFor: '*universes-client' stamp: 'ls 7/30/2004 15:01'!
applyToClient: aClient
	aClient newPackageList: packages! !

!UMPackageList methodsFor: 'converting' stamp: 'ls 7/28/2004 15:04'!
asStringArray
	^Array streamContents: [ :str |
		str nextPut: 'packages'.
		str nextPut: packages size printString.
		packages do: [ :pack |
			str nextPutAll: pack stringArrayEncoding ]. ].! !

!UMPackageList methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 12:01'!
packages: aCollection
	packages := aCollection! !

UMessage subclass: #UMPackageRemoved
	instanceVariableNames: 'packageName version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMPackageRemoved commentStamp: '<historical>' prior: 0!
A message claiming that a package has been removed.!

!UMPackageRemoved class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:58'!
fromStringArray: array
	^self packageName: array second version: (UVersion readFromString: array third)! !

!UMPackageRemoved class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:58'!
packageName: aString version: aVersion
	^self basicNew
		packageName: aString version: aVersion;
		yourself! !

!UMPackageRemoved methodsFor: '*universes-client' stamp: 'ls 7/30/2004 15:02'!
applyToClient: aClient
	aClient removedPackageNamed: packageName  withVersion: version! !

!UMPackageRemoved methodsFor: 'converting' stamp: 'ls 7/28/2004 14:57'!
asStringArray
	^{'packageremoved' . packageName . version printString }! !

!UMPackageRemoved methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:57'!
packageName: aString  version: aVersion
	packageName := aString.
	version := aVersion.! !

UMessage subclass: #UMProtocolVersion
	instanceVariableNames: 'version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMProtocolVersion commentStamp: '<historical>' prior: 0!
Tell the receiver what protocol version the sender understands.  The receiver should not send messages back which use a newer protocol version.
!

!UMProtocolVersion class methodsFor: 'instance creation' stamp: 'ls 2/15/2005 21:40'!
fromStringArray: array
	^self version: (Integer readFromString: array second)! !

!UMProtocolVersion class methodsFor: 'instance creation' stamp: 'ls 2/15/2005 21:40'!
version: anInteger
	^self new version: anInteger; yourself! !

!UMProtocolVersion methodsFor: 'applying' stamp: 'ls 2/15/2005 21:41'!
applyToClient: client! !

!UMProtocolVersion methodsFor: 'applying' stamp: 'ls 2/15/2005 21:42'!
applyToEditor: editor! !

!UMProtocolVersion methodsFor: 'applying' stamp: 'ls 2/15/2005 21:42'!
applyToMultiServer: server forConnection: connection! !

!UMProtocolVersion methodsFor: 'applying' stamp: 'ls 2/15/2005 21:41'!
applyToServer: server forConnection: connection! !

!UMProtocolVersion methodsFor: 'converting' stamp: 'ls 2/15/2005 21:41'!
asStringArray
	^{'protocolversion' . version asString}! !

!UMProtocolVersion methodsFor: 'attributes' stamp: 'ls 2/15/2005 21:40'!
version
	^version! !

!UMProtocolVersion methodsFor: 'initialize-release' stamp: 'ls 2/15/2005 21:39'!
version: anInteger
	version := anInteger! !

UMessage subclass: #UMRemovePackage
	instanceVariableNames: 'username password packageName packageVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMRemovePackage commentStamp: '<historical>' prior: 0!
A request to remove a package from a universe.
!

!UMRemovePackage class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 17:26'!
fromStringArray: array
	^self username: array second password: array third packageName: array fourth packageVersion: (UVersion readFromString: array fifth)! !

!UMRemovePackage class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:41'!
username: username password: password packageName: packageName packageVersion: packageVersion
	^self basicNew username: username password: password packageName: packageName packageVersion: packageVersion! !

!UMRemovePackage methodsFor: '*universes-server' stamp: 'ls 7/28/2004 17:20'!
applyToServer: server forConnection: connection
	server connection: connection requestedForUsername: username andPassword: password toRemovePackageNamed: packageName withVersion: packageVersion! !

!UMRemovePackage methodsFor: 'converting' stamp: 'ls 7/29/2004 15:46'!
asStringArray
	^{'removepackage' . username . password . packageName . packageVersion printString }
! !

!UMRemovePackage methodsFor: 'logging' stamp: 'ls 5/28/2007 17:43'!
maybeLogMessage
	"Return a string for logging this message, if there is one"
	^'RemovePackage ', username, ' ', packageName, '/', packageVersion printString! !

!UMRemovePackage methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:39'!
username: username0 password: password0 packageName: packageName0 packageVersion: packageVersion0
	username := username0.
	password := password0.
	packageName := packageName0.
	packageVersion := packageVersion0.
	! !

UMessage subclass: #UMRequestPackages
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMRequestPackages commentStamp: '<historical>' prior: 0!
A package requesting that a copy of all packages in the server's universe.!

!UMRequestPackages class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 11:59'!
fromStringArray: array
	^self basicNew! !

!UMRequestPackages methodsFor: '*universes-server' stamp: 'ls 7/28/2004 13:08'!
applyToServer: server forConnection: connection
	connection nextPut: (UMPackageList packages: server universe packages) asStringArray
! !

!UMRequestPackages methodsFor: 'converting' stamp: 'ls 7/28/2004 11:59'!
asStringArray
	^#('requestpackages')! !

UMessage subclass: #UMSelectServer
	instanceVariableNames: 'shortName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMSelectServer commentStamp: 'ls 2/13/2005 16:05' prior: 0!
A request to a multi-server, to select the server for a specific universe.  Subsequent messages should be directed to the selected universe instead of to the specific universes.!

!UMSelectServer class methodsFor: 'instance creation' stamp: 'ls 2/13/2005 16:06'!
fromStringArray: stringArray
	^self shortName: stringArray second! !

!UMSelectServer class methodsFor: 'instance creation' stamp: 'ls 2/13/2005 16:06'!
shortName: aString
	^self new
		shortName: aString;
		yourself! !

!UMSelectServer methodsFor: '*universes-server' stamp: 'ls 2/13/2005 16:18'!
applyToMultiServer: server forConnection: connection
	server switchConnection: connection toServerNamed: shortName! !

!UMSelectServer methodsFor: '*universes-server' stamp: 'ls 8/26/2007 12:05'!
applyToServer: server forConnection: connection
	"do nothing"
! !

!UMSelectServer methodsFor: 'converting' stamp: 'ls 2/13/2005 16:06'!
asStringArray
	^{'selectserver' . shortName}! !

!UMSelectServer methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 16:12'!
shortName: aString
	shortName := aString! !

!UMessage class methodsFor: 'instance creation' stamp: 'ls 2/15/2005 21:41'!
fromStringArray: array
	| class |
	class := nil.
	array first = 'requestpackages' ifTrue: [ class := UMRequestPackages ].
	array first = 'packages' ifTrue: [ class := UMPackageList ].
	array first = 'error' ifTrue: [ class := UMError ].
	array first = 'addaccount' ifTrue: [ class := UMAddAccount ].
	array first = 'addpackage' ifTrue: [ class := UMAddPackage ].
	array first = 'editaccount' ifTrue: [ class := UMEditAccount ].
	array first = 'editedaccount' ifTrue: [ class := UMEditedAccount ].
	array first = 'packageadded' ifTrue: [ class := UMPackageAdded ].
	array first = 'packageremoved' ifTrue: [ class := UMPackageRemoved ].
	array first = 'removepackage' ifTrue: [ class := UMRemovePackage ].
	array first = 'selectserver' ifTrue: [ class := UMSelectServer ].
	array first = 'protocolversion' ifTrue: [ class := UMProtocolVersion ].

	class ifNil: [
			^UMMalformed fromStringArray: array ].
	
	^[ class fromStringArray: array ] on: Error do: [ :ex | UMMalformed fromStringArray: array ]! !

!UMessage methodsFor: '*universes-client' stamp: 'ls 7/30/2004 15:00'!
applyToClient: aClient
	"apply this message to a UUniverseClient"
	! !

!UMessage methodsFor: '*universes-editor' stamp: 'ls 7/28/2004 15:40'!
applyToEditor: editor
	! !

!UMessage methodsFor: '*universes-server' stamp: 'ls 2/13/2005 16:18'!
applyToMultiServer: server  forConnection: connection
	connection nextPut: (UMError description: 'message inappropriate for multi-server') asStringArray! !

!UMessage methodsFor: '*universes-server' stamp: 'ls 7/28/2004 17:25'!
applyToServer: server  forConnection: connection
self inspect.
	connection nextPut: (UMError description: 'message inappropriate for server') asStringArray! !

!UMessage methodsFor: 'converting' stamp: 'ls 7/28/2004 11:30'!
asStringArray
	^self subclassResponsibility! !

!UMessage methodsFor: 'logging' stamp: 'ls 5/28/2007 17:22'!
maybeLogMessage
	"Return a string for logging this message, if there is one"
	^nil! !

Object subclass: #UOneShotConnection
	instanceVariableNames: 'inputMessage outputQueue hasBeenRead hasBeenWritten'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Server'!

!UOneShotConnection commentStamp: '<historical>' prior: 0!
A fake StringSocket used to integrate a UUniverseServer with an HTTP server.

A OneShotConnection has exactly one input message and only accepts one output message.  It puts the supplied output message onto a SharedQueue and then disconnects itself.
!

!UOneShotConnection class methodsFor: 'instance creation' stamp: 'ls 8/2/2004 16:31'!
withInMessage: inMessage0  andOutQueue: aSharedQueue
	^self basicNew
		initializeWithInMessage: inMessage0  andOutQueue: aSharedQueue;
		yourself! !

!UOneShotConnection methodsFor: 'string socket' stamp: 'ls 8/2/2004 16:33'!
destroy
	hasBeenWritten := true! !

!UOneShotConnection methodsFor: 'initialize-release' stamp: 'ls 8/2/2004 16:33'!
initializeWithInMessage: inMessage0  andOutQueue: aSharedQueue
	inputMessage := inMessage0.
	outputQueue := aSharedQueue.
	hasBeenRead := false.
	hasBeenWritten := false.! !

!UOneShotConnection methodsFor: 'string socket' stamp: 'ls 8/2/2004 16:34'!
isConnected
	^hasBeenWritten not! !

!UOneShotConnection methodsFor: 'string socket' stamp: 'ls 8/2/2004 16:32'!
nextOrNil
	hasBeenRead ifTrue:[ ^nil ].
	hasBeenRead := true.
	^inputMessage! !

!UOneShotConnection methodsFor: 'string socket' stamp: 'nice 3/19/2010 19:07'!
nextPut: anObject
	outputQueue nextPut: anObject.
	hasBeenWritten := true.
	^anObject! !

!UOneShotConnection methodsFor: 'string socket' stamp: 'ls 8/2/2004 16:32'!
processIO! !

Object subclass: #UPackage
	instanceVariableNames: 'name version category description provides depends url homepage maintainer squeakMapID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Model'!

!UPackage commentStamp: 'ls 7/27/2004 21:20' prior: 0!
One release of one package.!

!UPackage class methodsFor: '*universes-messages' stamp: 'ls 8/26/2007 12:01'!
decodeFromStringStream: str
	| package numDepends homePageText numProvides numConflicts urlString |
	package := self new.
	package name: str next.
	package version: (UVersion readFromString: str next).
	package description: str next.
	urlString := str next.
	(urlString withBlanksTrimmed beginsWith: '(') ifFalse: [
		(urlString withBlanksTrimmed beginsWith: 'http://(') ifFalse: [
			package url: (Url absoluteFromText: urlString) ] ].

	homePageText := str next.
	package homepage: (homePageText isEmpty ifTrue: [ nil ] ifFalse: [ homePageText asUrl ]).

	package maintainer: str next.

	numProvides := Integer readFromString: str next. 
	package provides: (str next: numProvides).
	numDepends := Integer readFromString: str next. 
	package depends: (str next: numDepends).
	numConflicts := Integer readFromString: str next. 
	str next: numConflicts.  "skip them"

	str atEnd ifFalse: [
		package category: (UPackageCategory readFromString: str next)].
	
	str atEnd ifFalse: [
		| idstr |
		idstr := str next.
		idstr isEmpty ifFalse: [
			package squeakMapID:  (UUID fromString: idstr) ].
		].
	
	^package
! !

!UPackage class methodsFor: 'decoding' stamp: 'ls 8/26/2007 12:01'!
decodeFromXMLElement: doc
	| package urlString |
	package := self new.

	package name: (self getXMLPartNamed: 'name' from: doc).
	package version: (UVersion readFromString: (self getXMLPartNamed: 'version' from: doc)).
	package description: (self getXMLPartNamed: 'description' from: doc).
	urlString := self getXMLPartNamed: 'url' from: doc.
	urlString isEmpty ifFalse: [
		(urlString withBlanksTrimmed beginsWith: 'http://(') ifFalse: [
	 		package url: (Url absoluteFromText: urlString). ] ].
	(doc elementAt: 'homepage') ifNotNil: [
		package homepage: (Url absoluteFromText: (self getXMLPartNamed: 'homepage' from: doc)) ].
	package maintainer: (self getXMLPartNamed: 'maintainer' from: doc).
	package provides: (self getXMLPackageList: 'provides' from: doc).
	package depends: (self getXMLPackageList: 'depends' from: doc).
	(doc elementAt: 'category') ifNotNil: [
		package category: (UPackageCategory readFromString: (self getXMLPartNamed: 'category' from: doc ))].
	(doc elementAt: 'squeakMapID') ifNotNil: [
		| idstr |
		idstr := self getXMLPartNamed: 'squeakMapID' from: doc.
		idstr isEmpty ifFalse: [
			package squeakMapID: (UUID fromString: idstr)]].
	^package! !

!UPackage class methodsFor: 'decoding' stamp: 'ls 2/13/2005 13:24'!
decodePackagesFromXMLStream: stream
	| doc |
	doc := XMLDOMParser parseDocumentFrom: stream.
	^doc elements collect: [ :element | self decodeFromXMLElement: element ].
! !

!UPackage class methodsFor: 'decoding' stamp: 'ls 2/13/2005 13:12'!
getXMLPackageList: listname from: element
	| listElement |
	listElement := element elementAt: listname.
	listElement ifNil: [ ^#() ].
	^listElement elements collect: [ :nameXML |
		nameXML contents first string ]
! !

!UPackage class methodsFor: 'decoding' stamp: 'ls 2/2/2007 15:00'!
getXMLPartNamed: partName  from: xmlDoc
	| element |
	element := xmlDoc elementAt: partName.
	(element isNil or: [ element contents isEmpty ]) ifTrue:[ ^ '' ].
	^element contents first string! !

!UPackage class methodsFor: 'decoding' stamp: 'ls 2/13/2005 13:41'!
readPackageListFromFileNamed: filename
	| file packages |
	file := FileStream readOnlyFileNamed: filename.
	packages := self decodePackagesFromXMLStream: file.
	file close.
	^packages! !

!UPackage class methodsFor: 'saving' stamp: 'ls 2/13/2005 14:47'!
savePackageList: packageList  onFileNamed: filename
	| tmpName file |
	tmpName := filename, 'tmp'.
	FileDirectory default deleteFileNamed: tmpName ifAbsent:  [].

	file := FileStream fileNamed: tmpName.
	packageList do: [ :package |
		file nextPutAll: package xmlForExport ].
	file close.

	FileDirectory default rename: tmpName toBe: filename.
! !

!UPackage methodsFor: 'comparing' stamp: 'tfel 9/16/2009 00:20'!
= anotherPackage
	self hash = anotherPackage hash ifFalse: [ ^false ].

	self name = anotherPackage name ifFalse: [ ^false ].
	self version = anotherPackage version ifFalse: [ ^false ].
	self category = anotherPackage category ifFalse: [ ^false ].
	self depends = anotherPackage depends ifFalse: [ ^false ].
	self provides = anotherPackage provides ifFalse: [ ^false ].
	self squeakMapID = anotherPackage squeakMapID ifFalse: [ ^false ].
	self url asString = anotherPackage url asString ifFalse: [ ^false ].
	self maintainer = anotherPackage maintainer ifFalse: [ ^false ].
	self homepage isNil = anotherPackage homepage isNil ifFalse: [ ^false ].
	(self homepage isNil or: [ 
		self homepage asString = anotherPackage homepage asString]) ifFalse: [ ^false ].

	self description = anotherPackage description ifFalse:[ ^false ].

	^true
! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:19'!
addDependency: aString
	depends add: aString! !

!UPackage methodsFor: 'installing' stamp: 'ls 5/13/2007 18:10'!
cachedCopyFilename
	"Download the package to a local cache, if it is not already in the cache.  Return the filename of the file in the cache.  If the package has no URL, download nothing and return nil."
	| filename doc file downloadDir |
	self url ifNil: [ ^nil ].
	
	downloadDir := FileDirectory default directoryNamed: 'universetmp'.
	downloadDir assureExistence.
	
	filename := self url path last.
	(downloadDir isAFileNamed: filename)
	ifFalse: [
		"download the file"
		doc := url retrieveContents.
		((doc contentType asString = 'text/plain') and: [
			doc content beginsWith: 'error']) ifTrue: [
			"HACK to see if the download failed; the real solution is to make retrieveContents report errors"
			^self error: 'download failed' ].
		file := downloadDir newFileNamed: filename.
		file binary.
		file nextPutAll: doc content.
		file close. ].

	^ (downloadDir fullNameFor: filename).! !

!UPackage methodsFor: 'accessing' stamp: 'ls 11/26/2006 10:54'!
category
	^ category ifNil: [self defaultCategory]! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 11/26/2006 11:10'!
category: aPackageCategory
	category := aPackageCategory! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 1/13/2007 14:41'!
categoryString: aString
	self category: (UPackageCategory readFromString: aString).
! !

!UPackage methodsFor: 'miscellania' stamp: 'ls 11/26/2006 11:07'!
defaultCategory
	^ UPackageCategory withComponents: #('Uncategorized' )! !

!UPackage methodsFor: 'accessing' stamp: 'ls 7/28/2004 09:53'!
depends
	^depends! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 7/29/2004 15:39'!
depends: aCollection
	depends := Set withAll: aCollection! !

!UPackage methodsFor: 'accessing' stamp: 'ls 7/28/2004 09:53'!
description
	^description! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:17'!
description: aString
	description := aString! !

!UPackage methodsFor: 'comparing' stamp: 'ls 7/28/2004 09:58'!
hash
	^self name hash bitXor: self version hash! !

!UPackage methodsFor: 'accessing' stamp: 'ls 2/13/2005 18:05'!
homepage
	"a homepage describing the package, or nil if there isn't one"
	^homepage! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 12:20'!
homepage: aURL
	homepage := aURL! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 11/5/2007 12:28'!
initialize
	name := '(unnamed package)'.
	version := UVersion readFromString: '0'.
	category := self defaultCategory.
	depends := Set new.
	provides := Set new.
	description := ''.
	url := nil.
	homepage := nil.
	maintainer := ''! !

!UPackage methodsFor: 'installing' stamp: 'dc 7/24/2007 11:40'!
install
	self url ifNil: [^ self].
	UPackageInstaller installFileNamed: self cachedCopyFilename! !

!UPackage methodsFor: 'testing' stamp: 'ls 12/31/2006 16:11'!
isPackageCategory
	^false! !

!UPackage methodsFor: 'comparing' stamp: 'ls 11/26/2006 12:34'!
isUPackage
	^true! !

!UPackage methodsFor: 'printing' stamp: 'ls 8/31/2007 12:25'!
longDescription
	^Text streamContents: [ :str |
		str nextPutAll: self description; cr; cr.
		str nextPutAll: 'Category: '; print: self category; cr.
		self provides isEmpty ifFalse: [
			str nextPutAll: 'Provides:'; cr.
			self provides do: [ :depName |
				str tab; nextPutAll: depName; cr ].
			str cr].
		self  depends isEmpty ifFalse: [
			str nextPutAll: 'Depends on:'; cr.
			self  depends do: [ :depName |
				str tab; nextPutAll: depName; cr ].
			str cr].
		str nextPutAll: ('Maintained by: ', self  maintainer); cr.
		str nextPutAll: 'Downloads from: '.
		self  url ifNil: [ str nextPutAll: '(no url)' ] ifNotNil: [ str nextPutAll: self  url asString ].
		str cr.
		self  homepage ifNotNil: [
			str nextPutAll: 'Homepage: '.
			str nextPutAll: (Text string: self homepage asString attribute: (TextURL new url: self homepage asString)).
			str cr].
		self squeakMapID ifNotNil: [
			| smurl |
			str nextPutAll: 'SqueakMap UUID: ', self squeakMapID asString, String cr.

			smurl := 'http://map.squeak.org/package/', self squeakMapID asString.
			str nextPutAll: (Text string: '[browse SqueakMap web page]' attribute: (TextURL new url: smurl)).
			str cr.
			
			str nextPutAll: (Text string: '[open SqueakMap browser]' attribute: (TextDoIt evalString: 'USqueakMapUtil browsePackageID: (UUID fromString: ''', self squeakMapID asString, ''')')).
			str cr.
			]. ] .
! !

!UPackage methodsFor: 'accessing' stamp: 'ls 2/13/2005 12:33'!
maintainer
	^maintainer ifNil: [ '' ]! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 12:32'!
maintainer: aString
	maintainer := aString! !

!UPackage methodsFor: 'accessing' stamp: 'ls 7/28/2004 09:53'!
name
	^name! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:17'!
name: aString
	name := aString! !

!UPackage methodsFor: 'accessing' stamp: 'ls 8/26/2007 09:18'!
packageSpec
	^UPackageSpec name: name version: version! !

!UPackage methodsFor: 'printing' stamp: 'ls 7/27/2004 21:19'!
printOn: aStream
	aStream
		nextPutAll: name;
		nextPutAll: ' version ';
		print: version! !

!UPackage methodsFor: 'serializing' stamp: 'ls 2/13/2005 13:29'!
printXMLPackageList: names on: stream
	names do: [ :n |
		stream nextPutAll: ' <packagename>'; nextPutAll: n escapeEntities; nextPutAll: '</packagename>' ].! !

!UPackage methodsFor: 'accessing' stamp: 'ls 2/13/2005 12:29'!
provides
	^provides ifNil: [ Set new ]! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 12:27'!
provides: aCollection
	provides := Set withAll: aCollection! !

!UPackage methodsFor: 'accessing' stamp: 'ls 8/26/2007 11:37'!
squeakMapID
	^ squeakMapID! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 8/26/2007 11:38'!
squeakMapID: aUUID 
	squeakMapID := aUUID! !

!UPackage methodsFor: '*universes-messages' stamp: 'tfel 9/16/2009 00:21'!
stringArrayEncoding
	^Array streamContents: [ :str |
		str
			nextPut: self name;
			nextPut: self version printString;
			nextPut: self description;
			nextPut: (self url ifNil: [ '(no download url)' ] ifNotNil: [ self url asString ]);
			nextPut: (self homepage ifNil: [ '' ] ifNotNil: [ self homepage asString ]);
			nextPut: self maintainer;
			nextPut: self provides size printString;
			nextPutAll: self provides;
			nextPut: self depends size printString;
			nextPutAll: self depends;
			nextPut: 0 printString;  "legacy conflicts field"
			nextPut: self category printString;
			nextPut: (self squeakMapID ifNil: [''] ifNotNil: [self squeakMapID asString])].! !

!UPackage methodsFor: 'accessing' stamp: 'ls 10/19/2006 10:30'!
url
	"The location of the package to install.  If it is nil, then the package is virtual and only has meaning for its dependencies."
	^url! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:18'!
url: aURL
	url := aURL! !

!UPackage methodsFor: 'accessing' stamp: 'ls 7/27/2004 21:32'!
version
	^version! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:17'!
version: aVersion
	version := aVersion.
	! !

!UPackage methodsFor: 'serializing' stamp: 'tfel 9/16/2009 00:24'!
xmlForExport
	^String streamContents: [ :str |
		str
			nextPutAll: '<package>'; cr;
			nextPutAll: '<name>'; nextPutAll: self name escapeEntities; nextPutAll: '</name>'; cr;
			nextPutAll: '<version>'; nextPutAll:  self version printString escapeEntities; nextPutAll: '</version>'; cr;
			nextPutAll: '<category>'; print: self category; nextPutAll: '</category>'; cr;
			nextPutAll: '<description>'; nextPutAll: self description escapeEntities; nextPutAll: '</description>'; cr.
		self url ifNotNil: [
			str nextPutAll: '<url>'; nextPutAll: self url asString escapeEntities; nextPutAll: '</url>'; cr ].
		self homepage ifNotNil: [
			str nextPutAll: '<homepage>'; nextPutAll:  self homepage asString escapeEntities; nextPutAll: '</homepage>'; cr ].
		str nextPutAll: '<maintainer>'; nextPutAll: self maintainer escapeEntities; nextPutAll: '</maintainer>'; cr.
			
		str nextPutAll: '<provides>'.
		self printXMLPackageList: self provides on: str.
		str nextPutAll: '</provides>'.
		str nextPutAll: '<depends>'.
		self printXMLPackageList: self depends on: str.
		str nextPutAll: '</depends>'.
		squeakMapID ifNotNil: [
			str nextPutAll: '<squeakMapID>'.
			str nextPutAll: squeakMapID asString.
			str nextPutAll: '</squeakMapID>'.
			].

		str nextPutAll: '</package>'; cr. ]! !

Object subclass: #UPackageCategory
	instanceVariableNames: 'components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Model'!

!UPackageCategory commentStamp: 'ls 11/26/2006 10:59' prior: 0!
A category for a package.!

!UPackageCategory class methodsFor: 'instance creation' stamp: 'ls 11/26/2006 11:03'!
readFrom: aStream
	"[UPackageCategory readFromString: 'Core/Umbrella Packages']"
	| comps nextComp |
	comps := OrderedCollection new.
	[aStream atEnd] whileFalse: [
		nextComp := (aStream upTo: $/) withBlanksTrimmed.
		nextComp isEmpty ifFalse: [
			comps add: nextComp ] ].
	
	^self withComponents: comps! !

!UPackageCategory class methodsFor: 'instance creation' stamp: 'ls 11/26/2006 12:21'!
root
	^self withComponents: #()! !

!UPackageCategory class methodsFor: 'instance creation' stamp: 'ls 11/26/2006 11:05'!
withComponents: anArrayOfStrings
	^self basicNew initialize: (Array withAll: anArrayOfStrings)! !

!UPackageCategory methodsFor: 'comparing' stamp: 'ls 12/31/2006 16:10'!
= aCategory
	^aCategory isPackageCategory and: [
		components = aCategory components ]! !

!UPackageCategory methodsFor: 'attributes' stamp: 'ls 11/26/2006 11:05'!
components
	^components! !

!UPackageCategory methodsFor: 'comparing' stamp: 'ls 11/26/2006 11:06'!
hash
	^components hash! !

!UPackageCategory methodsFor: 'initialize-release' stamp: 'ls 11/26/2006 10:59'!
initialize
	components := #()! !

!UPackageCategory methodsFor: 'initialize-release' stamp: 'ls 11/26/2006 10:59'!
initialize: anArrayOfStrings
	components := anArrayOfStrings! !

!UPackageCategory methodsFor: 'testing' stamp: 'ls 12/31/2006 16:10'!
isPackageCategory
	^true! !

!UPackageCategory methodsFor: 'subcategories' stamp: 'ls 11/26/2006 12:20'!
isSubcategoryOf: prefix
	components isEmpty ifTrue: [ ^false ].
	^components allButLast = prefix components! !

!UPackageCategory methodsFor: 'comparing' stamp: 'ls 11/26/2006 12:33'!
isUPackageCategory
	^true! !

!UPackageCategory methodsFor: 'printing' stamp: 'ls 11/26/2006 11:04'!
printOn: aStream
	components do: [ :comp |
		aStream nextPutAll: comp ]
	separatedBy: [ aStream nextPut: $/ ]! !

Object subclass: #UPackageInstaller
	instanceVariableNames: ''
	classVariableNames: 'Installers'
	poolDictionaries: ''
	category: 'Universes-Installers'!

!UPackageInstaller commentStamp: '<historical>' prior: 0!
A simply hierarchy for loading Squeak content in various formats.!

UPackageInstaller subclass: #UIFileOut
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Installers'!

!UIFileOut methodsFor: 'testing' stamp: 'ls 9/4/2004 14:02'!
handlesFilename: filename
	^#('.cs' '.st' '.st.gz' '.cs.gz') anySatisfy: [ :ending | filename endsWith: ending ]! !

!UIFileOut methodsFor: 'installing' stamp: 'ls 7/29/2004 20:01'!
install: inStream  usingBaseName: basename
	"find a changeset name that is not used"
	| num changesetName stream |
	num := 0.
	[  	changesetName := basename.
	   	num > 0 ifTrue:[ changesetName := changesetName, '-', num printString. ].
		(ChangeSorter changeSetNamed: changesetName) notNil ]
	whileTrue: [ num := num + 1 ].
	
	"decompress if necessary"
	inStream peek asInteger = 16r1F
		ifTrue: [ stream := ReadStream on: ((GZipReadStream on: inStream) upToEnd) asString ]
		ifFalse: [ stream := inStream ].
		
	ChangeSorter newChangesFromStream: stream named: changesetName! !

UPackageInstaller subclass: #UIMonticello
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Installers'!

!UIMonticello methodsFor: 'testing' stamp: 'ls 8/19/2007 12:45'!
handlesFileEnding: ending
	ending = 'mcz' ifTrue: [ ^true ].
	(ending = 'mcm' and: [ self isMCMReaderAvailable ]) ifTrue: [ ^true ].
	^false! !

!UIMonticello methodsFor: 'installing' stamp: 'ls 8/19/2007 12:47'!
installFileNamed: filename 
	(filename asLowercase endsWith: '.mcm') 
		ifTrue: [^ self mcmReader loadVersionFile: filename].
	Smalltalk at: #MCMczReader
		ifPresent: [:reader | ^ reader loadVersionFile: filename].
	MczInstaller installFileNamed: filename! !

!UIMonticello methodsFor: 'testing' stamp: 'ls 8/19/2007 12:44'!
isMCMReaderAvailable
	^ Smalltalk includesKey: self mcmReaderClassName! !

!UIMonticello methodsFor: 'installing' stamp: 'ls 8/19/2007 12:46'!
mcmReader
	^ Smalltalk at: self mcmReaderClassName! !

!UIMonticello methodsFor: 'testing' stamp: 'ls 8/19/2007 12:44'!
mcmReaderClassName
	^ #MCMcmReader! !

UPackageInstaller subclass: #UIMpeg
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Installers'!

!UIMpeg methodsFor: 'testing' stamp: 'ls 7/29/2004 11:04'!
handlesFileEnding: ending
	^#('mpg' 'mpeg') includes: ending! !

!UIMpeg methodsFor: 'installing' stamp: 'ls 7/29/2004 11:39'!
install: stream usingBasename: basename
	| movieDir movieFile |
	movieDir := FileDirectory default directoryNamed: 'movies'.
	movieDir assureExistence.
	
	movieDir removeFileNamed: basename.
	
	movieFile := movieDir newFileNamed: basename, '.mpeg'.
	stream binary.  movieFile binary.
	movieFile nextPutAll: stream upToEnd.
	movieFile close.
	
	Smalltalk at: #MPEGMoviePlayerMorph ifPresent: [ :player |
		player playFile: (movieDir fullNameFor: basename, '.mpeg') ]! !

UPackageInstaller subclass: #UIProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Installers'!

!UIProject methodsFor: 'testing' stamp: 'ls 7/29/2004 11:05'!
handlesFileEnding: ending
	^#('pr') includes: ending! !

!UIProject methodsFor: 'installing' stamp: 'ls 9/18/2004 18:18'!
installFileNamed: filename
	FileDirectory splitName: filename to: [ :path :base |
		[ 	
			ProjectViewMorph openFromDirectory: (FileDirectory on: path) andFileName: base
		] on: ProjectEntryNotification do:
		[ :ex |
			"don't enter it" ] ]! !

UPackageInstaller subclass: #UISar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Installers'!

!UISar methodsFor: 'testing' stamp: 'ls 7/29/2004 11:04'!
handlesFileEnding: ending
	^#('sar') includes: ending! !

!UISar methodsFor: 'installing' stamp: 'ls 7/29/2004 11:44'!
installFileNamed: filename
	SARInstaller installSAR: filename! !

!UPackageInstaller class methodsFor: 'initialization' stamp: 'ls 7/29/2004 11:09'!
initialize
	Installers ifNil: [ Installers := Set new ].
	
	{UIFileOut. UIMonticello. UIMpeg. UIProject. UISar} do: [ :c |
		self registerInstaller: c new ]! !

!UPackageInstaller class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 11:10'!
installFileNamed: filename
	(self installerForFilename: filename) installFileNamed: filename! !

!UPackageInstaller class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 11:10'!
installerForFilename: filename
	^self registeredInstallers detect: [ :i | i handlesFilename: filename ] ifNone: [ self error: 'no installer handles file ', filename ].! !

!UPackageInstaller class methodsFor: 'registry' stamp: 'ls 7/29/2004 11:02'!
registerInstaller: installer
	Installers add: installer! !

!UPackageInstaller class methodsFor: 'registry' stamp: 'ls 7/29/2004 11:11'!
registeredInstallers
	^Installers asArray! !

!UPackageInstaller methodsFor: 'comparing' stamp: 'ls 7/29/2004 11:02'!
= anInstaller
	^self class = anInstaller class! !

!UPackageInstaller methodsFor: 'testing' stamp: 'ls 7/29/2004 10:59'!
handlesFileEnding: anEnding
	^false! !

!UPackageInstaller methodsFor: 'testing' stamp: 'ls 7/29/2004 11:08'!
handlesFilename: filename
	^self handlesFileEnding: (FileDirectory extensionFor: filename)
	! !

!UPackageInstaller methodsFor: 'comparing' stamp: 'ls 7/29/2004 11:03'!
hash
	^self class hash! !

!UPackageInstaller methodsFor: 'installing' stamp: 'ls 7/29/2004 11:06'!
install: stream  usingBaseName: baseName
	self subclassResponsibility! !

!UPackageInstaller methodsFor: 'installing' stamp: 'ls 9/4/2004 15:02'!
installFileNamed: filename
	| stream baseName |
	stream := (FileStream readOnlyFileNamed: filename).
	baseName := (FileDirectory splitName: filename to: [:path :base|base]) copyUpTo: $. .

	self install: stream usingBaseName: baseName.
	stream close.
	! !

Object subclass: #UPackageSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Serialization'!

!UPackageSerializer commentStamp: 'ls 2/13/2005 12:49' prior: 0!
A class for loading and saving lists of packages!

Object subclass: #UPackageSpec
	instanceVariableNames: 'name version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Model'!

!UPackageSpec commentStamp: 'ls 8/26/2007 09:09' prior: 0!
The information needed to identify a package within a universe: a name plus a version.!

!UPackageSpec class methodsFor: 'instance creation' stamp: 'ls 8/26/2007 09:14'!
name: aString version: aUVersionOrString 
	^ self basicNew name: aString version: aUVersionOrString! !

!UPackageSpec class methodsFor: 'instance creation' stamp: 'ls 8/26/2007 09:13'!
new
	^self error: 'create instances with name:version:'! !

!UPackageSpec methodsFor: 'comparison' stamp: 'ls 8/26/2007 09:11'!
= aPackageSpec
	^(aPackageSpec isKindOf: UPackageSpec) and: [
		aPackageSpec name = name and: [
			aPackageSpec version = version ]]! !

!UPackageSpec methodsFor: 'comparison' stamp: 'ls 8/26/2007 09:18'!
hash
	^name hash bitXor: version hash! !

!UPackageSpec methodsFor: 'initialization' stamp: 'ls 8/26/2007 09:10'!
initialize
	super initialize.
	name := '(unnamed)'.
	version = UVersion readFromString: '0'! !

!UPackageSpec methodsFor: 'attributes' stamp: 'ls 8/26/2007 09:11'!
name
	^name! !

!UPackageSpec methodsFor: 'initialization' stamp: 'ls 8/26/2007 09:14'!
name: aString version: aUVersionOrString
	name := aString.
	version := aUVersionOrString asUVersion.
	! !

!UPackageSpec methodsFor: 'printing' stamp: 'ls 8/26/2007 09:17'!
printOn: aStream
	aStream
		nextPutAll: name;
		nextPutAll: '/';
		print: version! !

!UPackageSpec methodsFor: 'attributes' stamp: 'ls 8/26/2007 09:11'!
version
	^version! !

Object subclass: #UPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Policy'!

!UPolicy commentStamp: '<historical>' prior: 0!
A policy for manipulations on a universe.  All of the methods return 'true' on success or on allowing the requested operation, or 'false' on an error or if the operation is not allowed.  By default everything is disallowed.

Note that since policy is completely implemented on the server, there is no requirement that a particular UUniverse has a policy describable with this class or a subclass.  A particular server can always modify UUniverseServer to implement an arbitrary policy.!

UPolicy subclass: #UPStable
	instanceVariableNames: 'masterUser masterPassword'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Policy'!

!UPStable commentStamp: '<historical>' prior: 0!
A policy somewhat suitable for stable versions.  All updates must come through a single master userid and password.!

!UPStable methodsFor: 'policies' stamp: 'ls 7/29/2004 17:59'!
addUser: user withPassword: password andEmail: email
	^UPolicyResponse denied! !

!UPStable methodsFor: 'policies' stamp: 'ls 3/11/2007 00:04'!
changeUser: user withPassword: password toHavePassword: newPassword andNewEmail: newEmail
	"the changes must be made on the server, not over the standard protocol"
	^UPolicyResponse denied! !

!UPStable methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 22:08'!
masterPassword: password
	masterPassword := password! !

!UPStable methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 22:08'!
masterUser: userName
	masterUser := userName! !

!UPStable methodsFor: 'policies' stamp: 'ls 7/29/2004 18:00'!
package: package mayBeAddedBy: user withPassword: password
	^(user = masterUser and: [ password = masterPassword ])
		ifTrue: [ UPolicyResponse allowed ]
		ifFalse: [ UPolicyResponse denied ]! !

!UPStable methodsFor: 'policies' stamp: 'ls 7/29/2004 18:00'!
packageNamed: packageName  withVersion: version  mayBeRemovedBy: user  withPassword: password
	(user = masterUser and: [ password = masterPassword ])
		ifTrue: [ ^UPolicyResponse allowed ]
		ifFalse: [ ^UPolicyResponse denied ]! !

UPolicy subclass: #UPWild
	instanceVariableNames: 'superUser accounts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Policy'!

!UPWild commentStamp: 'ls 4/14/2007 18:34' prior: 0!
This is the wild-n-wooly policy.  Anyone may create a new account, and the first person to try to add or remove a package with a given name comes to exclusively own that package name.  Only the owner of a package name may make changes to packages with that name.

As an exception, the supuser/suppassword may be used to change any package.  This is intended to allow a universe manager to override decisions made by package owners.!

!UPWild class methodsFor: 'reasonable names' stamp: 'ls 7/29/2004 16:51'!
isReasonablePackageName: aString
	^aString allSatisfy: [ :c | c isAlphaNumeric or: [ ' -.' includes: c ]]! !

!UPWild class methodsFor: 'reasonable names' stamp: 'ls 2/15/2005 23:45'!
isReasonableUsername: aString
	^aString isEmpty not and: [ aString allSatisfy: [ :c | c isAlphaNumeric ] ]! !

!UPWild methodsFor: 'policies' stamp: 'ls 5/13/2007 10:04'!
addUser: username withPassword: password  andEmail: email
	| newAccount |
	(accounts anySatisfy: [ :acc | acc username = username]) ifTrue: [
		"already an account here"
		^UPolicyResponse denied: 'account already exists' ].

	superUser ifNotNil: [
		superUser username = username ifTrue: [
			"cannot create an account with the superuser's name"
			^UPolicyResponse denied: 'same account name as the superuser' ] ].
		
	(self class isReasonableUsername: username) ifFalse: [
		^UPolicyResponse denied: 'invalid account name' ].
	
	newAccount := UAccount new.
	newAccount username: username.
	newAccount password: password.
	newAccount email: email.
	
	accounts add: newAccount.
	^UPolicyResponse allowed! !

!UPWild methodsFor: 'policies' stamp: 'ls 2/13/2005 16:38'!
changeUser: username withPassword: password toHavePassword: newPassword andNewEmail: newEmail
	| account |
	account := self findAccount: username withPassword: password.
	account ifNil: [ ^UPolicyResponse denied: 'username not present or password does not match' ].
	
	newPassword isEmpty ifFalse: [account password: newPassword ].
	newEmail isEmpty ifFalse: [account email: newEmail ].
	^UPolicyResponse allowed! !

!UPWild methodsFor: 'account assignment' stamp: 'ls 7/28/2004 18:14'!
findAccount: username withPassword: password
	| account |
	account := accounts detect: [ :acc | acc username = username] ifNone: [
		"no such account"
		^nil ].
	
	account password = password ifFalse:[
		"wrong password"
		^nil ].
	
	^account! !

!UPWild methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 21:35'!
initialize
	accounts := OrderedCollection new! !

!UPWild methodsFor: 'policies' stamp: 'ls 7/28/2004 21:34'!
package: aPackage  mayBeAddedBy: username  withPassword: password
	^self tryToGivePackageName: aPackage name toUsername: username withPassword: password! !

!UPWild methodsFor: 'policies' stamp: 'ls 7/28/2004 18:15'!
packageNamed: packageName withVersion: version mayBeRemovedBy: username withPassword: password
	^self tryToGivePackageName: packageName toUsername: username withPassword: password! !

!UPWild methodsFor: 'initialize-release' stamp: 'ls 4/14/2007 18:39'!
superUser: anAccount
	superUser ifNotNil: [
		accounts remove: superUser ].
	superUser := anAccount.
	accounts add: superUser.
	! !

!UPWild methodsFor: 'account assignment' stamp: 'ls 4/14/2007 18:40'!
tryToGivePackageName: packageName toUsername: username  withPassword: password
	| account |
	(self class isReasonablePackageName: packageName) ifFalse: [
		^UPolicyResponse denied: 'invalid package name' ].
	
	account := self findAccount: username withPassword: password.
	account ifNil: [ ^UPolicyResponse denied: 'incorrect password or no such user' ].

	account == superUser ifTrue: [
		^UPolicyResponse allowed ].

	(account ownsPackageName: packageName) ifTrue: [
		^UPolicyResponse allowed ].
	
	(accounts anySatisfy: [ :acc | acc ownsPackageName: packageName ]) ifTrue: [
		^UPolicyResponse denied: 'package is owned by another' ].
	
	account addPackageName: packageName.
	^UPolicyResponse allowed! !

UPolicy subclass: #UPermissivePolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Policy'!

!UPermissivePolicy commentStamp: '<historical>' prior: 0!
A policy that allows anything.
!

!UPermissivePolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:48'!
addUser: user  withPassword: password  andEmail: email
	^UPolicyResponse allowed! !

!UPermissivePolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:48'!
changeUser: user withPassword: password toHavePassword: newPassword andNewEmail: newEmail
	^UPolicyResponse allowed! !

!UPermissivePolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:48'!
package: aPackage  mayBeAddedBy: user  withPassword: password
	^UPolicyResponse allowed! !

!UPermissivePolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:48'!
packageNamed: packageName  withVersion: version  mayBeRemovedBy: user  withPassword: password
	^UPolicyResponse allowed! !

!UPolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:47'!
addUser: user  withPassword: password  andEmail: email
	^UPolicyResponse denied! !

!UPolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:47'!
changeUser: user withPassword: password toHavePassword: newPassword andNewEmail: newEmail
	^UPolicyResponse denied! !

!UPolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:47'!
package: aPackage  mayBeAddedBy: user  withPassword: password
	^UPolicyResponse denied! !

!UPolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:47'!
packageNamed: packageName  withVersion: version  mayBeRemovedBy: user  withPassword: password
	^UPolicyResponse denied! !

Object subclass: #UPolicyResponse
	instanceVariableNames: 'allowed reason'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Policy'!

!UPolicyResponse commentStamp: '<historical>' prior: 0!
A response to a policy query.!

!UPolicyResponse class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 16:47'!
allowed
	^self allowed: nil! !

!UPolicyResponse class methodsFor: 'instance creation' stamp: 'ls 7/30/2004 10:34'!
allowed: reason
	^self allowed: true  reason: reason! !

!UPolicyResponse class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 16:46'!
allowed: aBoolean  reason: aReason
	^self basicNew
		allowed: aBoolean;
		reason: (aReason ifNil: ['no reason given']);
		yourself! !

!UPolicyResponse class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 16:46'!
denied
	^self denied: nil! !

!UPolicyResponse class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 17:58'!
denied: reason
	^self allowed: false  reason: reason! !

!UPolicyResponse class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 16:47'!
new
	self shouldNotImplement ! !

!UPolicyResponse methodsFor: 'accessing' stamp: 'ls 7/29/2004 17:56'!
allowed
	^allowed! !

!UPolicyResponse methodsFor: 'accessing' stamp: 'ls 7/29/2004 17:56'!
allowed: anObject
	allowed := anObject! !

!UPolicyResponse methodsFor: 'accessing' stamp: 'ls 7/29/2004 17:58'!
reason
	^reason! !

!UPolicyResponse methodsFor: 'accessing' stamp: 'ls 7/29/2004 17:56'!
reason: anObject
	reason := anObject! !

Object subclass: #USqueakMapUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Browser'!

!USqueakMapUtil commentStamp: 'ls 8/31/2007 12:16' prior: 0!
Utilities for interfacing to SqueakMap.
!

!USqueakMapUtil class methodsFor: 'browsing' stamp: 'ls 8/31/2007 12:18'!
browsePackageID: packageID
	"open a SqueakMap browser on the specified package ID"
	Smalltalk at: #SMLoader ifPresent: [ :smloaderClass |
		| loader |
		loader := smloaderClass open.
		loader selectedItemWrapper: (loader packageWrapperList detect: [:pw | pw
withoutListWrapper id = packageID])]
! !

Object subclass: #UUniverseClient
	instanceVariableNames: 'universe inMessages outMessages socket stringSocket lastConnectionStart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Client'!

!UUniverseClient commentStamp: 'ls 7/30/2004 14:58' prior: 0!
A client for talking to a universe server.

The universe must be a UStandardUniverse.  The client will track update the universe automatically as messages come in.
!

!UUniverseClient class methodsFor: 'instance creation' stamp: 'ls 7/30/2004 15:06'!
forUniverse: aStandardUniverse
	^self basicNew
		initialize: aStandardUniverse;
		yourself! !

!UUniverseClient class methodsFor: 'class initialization' stamp: 'ls 2/13/2005 15:45'!
initialize
	Preferences removePreference: #universesUsesHTTP 
! !

!UUniverseClient class methodsFor: 'instance creation' stamp: 'ls 7/30/2004 15:06'!
new
	^self forUniverse: UUniverse systemUniverse! !

!UUniverseClient methodsFor: 'public' stamp: 'ls 7/30/2004 15:10'!
disconnect
	"explicitly close the connection"
	socket ifNotNil: [ socket destroy.  socket := nil ].
	stringSocket ifNotNil: [ stringSocket destroy.  stringSocket := nil ].! !

!UUniverseClient methodsFor: 'initialization' stamp: 'ls 8/5/2004 17:16'!
initialize: aUniverse
	universe := aUniverse.
	
	inMessages := OrderedCollection new.
	outMessages := OrderedCollection new.
	
	lastConnectionStart := DateAndTime epoch.! !

!UUniverseClient methodsFor: 'networking' stamp: 'ls 8/4/2004 15:46'!
newInMessage: aMessage
	aMessage applyToClient: self.
	inMessages add: aMessage.
	! !

!UUniverseClient methodsFor: 'package list' stamp: 'ls 7/30/2004 14:59'!
newPackageList: newPackages
	universe packages: newPackages.
	! !

!UUniverseClient methodsFor: 'package list' stamp: 'ls 7/30/2004 15:00'!
packageAdded: newPackage
	universe addPackage: newPackage! !

!UUniverseClient methodsFor: 'networking' stamp: 'ls 2/15/2005 21:44'!
processIO
	| rawMsg |
	(stringSocket notNil and: [ stringSocket isConnected not ]) ifTrue: [
		"connection has died"
		stringSocket destroy.
		stringSocket := nil ].

	
	(outMessages isEmpty not and: [ socket isNil and: [ stringSocket isNil ] ]) ifTrue: [
		"there are outgoing messages queued but there is no stringSocket"
		(DateAndTime now - lastConnectionStart) > (Duration minutes: 1) ifTrue: [
			self startConnecting ] ].
	
	socket ifNotNil: [
		"a connection is in progress"
		
		socket isConnected ifTrue: [
			"connection completed"
			stringSocket := StringSocket on: socket.
			universe shortName ifNotNil: [
				outMessages addFirst: (UMProtocolVersion version: 1).
				outMessages addFirst: (UMSelectServer shortName: universe shortName) ].
			socket := nil. ]
		ifFalse: [
			socket isWaitingForConnection ifFalse: [
				"the connection failed"
				inMessages add: (UMConnectionFailed description: 'connection failed').
				^self disconnect ] ] ].

	
	stringSocket ifNil: [ ^self ].
		
	[ outMessages isEmpty ] whileFalse: [
		stringSocket nextPut: outMessages removeFirst asStringArray ].
	
	stringSocket processIO.
	
	[	rawMsg := stringSocket nextOrNil.
		rawMsg isNil not
	] whileTrue: [ 
		self newInMessage: (UMessage fromStringArray: rawMsg) ]! !

!UUniverseClient methodsFor: 'public' stamp: 'ls 7/30/2004 15:33'!
receivedMessagesDo: aBlock
	"check for new messages, and then evaluate aBlock for each message that is currently available"
	self processIO.
	[ inMessages isEmpty ] whileFalse: [
		aBlock value: inMessages removeFirst ]! !

!UUniverseClient methodsFor: 'package list' stamp: 'ls 7/30/2004 15:02'!
removedPackageNamed: packageName  withVersion: version
	universe removePackageNamed: packageName  withVersion: version! !

!UUniverseClient methodsFor: 'public' stamp: 'ls 2/13/2005 15:18'!
sendMessage: aMessage
	"send the specified message to the server"
	outMessages add: aMessage! !

!UUniverseClient methodsFor: 'networking' stamp: 'ls 7/30/2004 15:31'!
startConnecting
	"start a new connection to the server"
	self disconnect.
	
	lastConnectionStart := DateAndTime now.
	
	socket := Socket newTCP.
	socket connectTo: (NetNameResolver addressForName: universe serverName) port: universe serverPort.
! !

!UUniverseClient methodsFor: 'networking' stamp: 'ls 1/13/2007 14:47'!
waitForMessage
	"return the next message from the server, waiting if necessary.  Many clients will find this method less convenient than polling on the non-blocking receivedMessagesDo:."
	[
		self receivedMessagesDo: [ :m | ^m ].
		(Delay forMilliseconds: 100) wait.
	] repeat.

! !

Object subclass: #UUniverseEditor
	instanceVariableNames: 'universe client username password email usernameField passwordField fields packageEditors accountEditor selectedPackageIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Editor'!

!UUniverseEditor commentStamp: '<historical>' prior: 0!
A tool for editing a remote universe.
!

!UUniverseEditor class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 10:23'!
forUniverse: aStandardUniverse
	^self basicNew
		initialize: aStandardUniverse;
		yourself! !

!UUniverseEditor class methodsFor: 'class initialization' stamp: 'mt 5/10/2015 14:00'!
initialize

	#('Universe Editor' 'Package Universe Editor') do: [:oldName |
		TheWorldMenu unregisterOpenCommand: oldName].

	"TheWorldMenu registerOpenCommand: {'Universe Editor'. {self. #open}}.
	Preferences setWindowColorFor: self name to: (Color r: 0.194 g: 0.645 b: 1.0)."! !

!UUniverseEditor class methodsFor: 'instance creation' stamp: 'ar 8/6/2009 19:17'!
new
	| choice choices |
	choices := UUniverse systemUniverse standardUniverses asArray.
	choices isEmpty ifTrue: [ ^self error: 'no standard universes installed' ].
	choices size = 1 ifTrue: [
		choice := choices anyOne ]
	ifFalse: [
		choice := UIManager default 
				chooseFrom: (choices collect: [ :u | u description ])
				values: choices
				title: 'edit which universe?'.
		choice ifNil: [ ^self ] ].
	
	^self forUniverse: choice! !

!UUniverseEditor class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 18:13'!
open
	^self new open! !

!UUniverseEditor class methodsFor: 'class initialization' stamp: 'mt 5/10/2015 14:00'!
unload
	
	#('Universe Editor' 'Package Universe Editor') do: [:oldName |
		TheWorldMenu unregisterOpenCommand: oldName].
! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 17:34'!
acceptFields
	fields do: [ :f | f accept ]! !

!UUniverseEditor methodsFor: 'account' stamp: 'ls 7/28/2004 18:00'!
accountUpdatedWithUsername: newUsername  password:  newPassword  email: newEmail
	self acceptFields.
	username := newUsername.
	password := newPassword.
	email := newEmail.
	
	self changed: #username.
	self changed: #password.
	self changed: #email.
	
	self closeAccountEditor! !

!UUniverseEditor methodsFor: 'package list' stamp: 'ls 2/13/2005 16:25'!
anyPackageSelected
	^selectedPackageIndex > 0! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 17:58'!
closeAccountEditor
	accountEditor ifNil: [ ^self ].
	accountEditor window delete.
	accountEditor := nil.! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 17:12'!
closeEditorForPackage: package
	| matchingEditors |
	matchingEditors := packageEditors select: [ :p | p package = package ].
	matchingEditors do: [ :editor |
		editor window delete.
		packageEditors remove: editor ].! !

!UUniverseEditor methodsFor: 'account' stamp: 'ls 2/13/2005 16:31'!
createAccount
	self acceptFields.

	email := FillInTheBlankMorph request: 'your email address?'.
	email = '' ifTrue: [ ^self ].

	self sendMessage: (UMAddAccount username: username password: password email: email).
	! !

!UUniverseEditor methodsFor: 'package editing' stamp: 'cmm 3/9/2010 15:15'!
createNewPackage
	| package |
	package := UPackage new.
	Utilities authorInitialsPerSe isEmptyOrNil ifFalse: [
		package maintainer: Utilities authorInitialsPerSe
	].
	^package! !

!UUniverseEditor methodsFor: 'account' stamp: 'ls 2/13/2005 16:52'!
editAccount
	| editor |
	self acceptFields.
	self closeAccountEditor.
	
	editor := UAccountEditor
		username: username
		password: password
		email:  ''
		whenDone: [ :oldPassword :newPassword :newEmail |
			password := oldPassword.
			self sendMessage: (UMEditAccount username: username password: password newPassword: newPassword newEmail: newEmail) ].
		
	editor openInMorphic.
	
	accountEditor := editor.! !

!UUniverseEditor methodsFor: 'initialization' stamp: 'ls 2/13/2005 17:16'!
initialize: universe0
	universe := universe0.
	universe addDependent: self.

	client := UUniverseClient forUniverse: universe.
	username := Utilities authorInitialsPerSe.
	password := ''.
	
	packageEditors := Set new.

	selectedPackageIndex := 0.
! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 16:02'!
makeButtonWithAction: selector andGetState: getStateSelector andLabel: aString
	^(PluggableButtonMorph on: self getState: getStateSelector action: selector)
		label: aString;
		useRoundedCorners;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		onColor: self defaultBackgroundColor offColor: self defaultBackgroundColor muchLighter;
		yourself! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 16:02'!
makeButtonWithAction: selector  andLabel: aString
	^self makeButtonWithAction: selector andGetState: #returnTrue andLabel: aString! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 2/15/2005 22:02'!
morphicView
	| win universeDescription buttonList usernameRow passwordRow button  usernamePasswordArea packageList |
	win := SystemWindow labelled: 'Universe Editor'.
	win model: self.
	
	universeDescription := PluggableTextMorph on: self text: #universeDescription accept: nil.
	universeDescription hideScrollBarsIndefinitely.
	win addMorph: universeDescription frame: (0@0 extent: 1@0.1).
	
	buttonList := AlignmentMorph newColumn.
	buttonList cellInset: 0@3.
	win addMorph: buttonList frame: (0@0.5 extent: 0.5@0.5).
	
	
	usernamePasswordArea := AlignmentMorph newColumn.
	win addMorph: usernamePasswordArea frame: (0@0.1 extent: 0.5@0.4).

	usernameRow := UInterfaceUtilities makeFieldRowNamed: 'username' getSelector: #username setSelector: #username: for: self.
	usernamePasswordArea addMorphBack: usernameRow.
	
	passwordRow := UInterfaceUtilities makeFieldRowNamed: 'password:' getSelector: #password setSelector: #password: isPassword: true for: self.
	usernamePasswordArea addMorphBack: passwordRow.
	
	button := self makeButtonWithAction: #createAccount andLabel: 'createAccount'.
	buttonList addMorphBack: button.
	button := self makeButtonWithAction: #editAccount andLabel: 'edit account'.
	buttonList addMorphBack: button.
	button := self makeButtonWithAction: #newPackage andLabel: 'new package'.
	buttonList addMorphBack: button.
	button := self makeButtonWithAction: #newPackageVersion andGetState: #anyPackageSelected andLabel: 'new package version'.
	buttonList addMorphBack: button.
	button := self makeButtonWithAction: #removeVersion andGetState: #anyPackageSelected andLabel: 'remove package version'.
	buttonList addMorphBack: button.
	button := self makeButtonWithAction: #requestPackageList andLabel: 'update package list'.
	buttonList addMorphBack: button.

	packageList := PluggableListMorph on: self list: #packageDescriptions  selected: #selectedPackageIndex changeSelected: #selectedPackageIndex: menu: nil.
	win addMorph: packageList frame: ((0.5@0.1) extent: (0.5@0.9)).

	
	^win! !

!UUniverseEditor methodsFor: 'package editing' stamp: 'ls 11/16/2006 16:42'!
newPackage
	| editor |
	self acceptFields.

	editor := UPackageEditor package: self createNewPackage whenComplete: [ :p |
		self acceptFields.
		self sendMessage: (UMAddPackage username: username password: password package: p) ].
	editor openInMorphic.
	packageEditors add: editor.
! !

!UUniverseEditor methodsFor: 'package editing' stamp: 'ls 2/15/2005 22:06'!
newPackageVersion
	| package editor newPackage |
	self anyPackageSelected ifFalse: [ ^self ].
	self acceptFields.
	package := self selectedPackage.
	
	newPackage := package deepCopy.
	newPackage version: (UVersion readFromString: (newPackage version asString, 'new')).

	editor := UPackageEditor package: newPackage whenComplete: [ :p |
		self acceptFields.
		self sendMessage: (UMAddPackage username: username password: password package: p) ].

	editor openInMorphic.
	packageEditors add: editor.
! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 17:34'!
noteField: field 
	"note that the receiver has the specified text field"
	fields ifNil: [fields := OrderedCollection new].
	fields add: field! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 7/29/2004 16:27'!
open
	self morphicView openInWorld.
	"self requestPackageList."! !

!UUniverseEditor methodsFor: 'package list' stamp: 'ls 2/13/2005 16:26'!
packageDescriptions
	^self sortedPackages collect: [ :p |		
		p printString. ]! !

!UUniverseEditor methodsFor: 'package list' stamp: 'ls 12/31/2006 16:13'!
packagesChanged
	self selectedPackageIndex: 0.
	
	self changed: #packageDescriptions.
	self changed: #rootCategoriesAndPackages.
! !

!UUniverseEditor methodsFor: 'attributes' stamp: 'ls 7/28/2004 15:54'!
password
	^password! !

!UUniverseEditor methodsFor: 'attributes' stamp: 'ls 7/28/2004 16:18'!
password: aString
	password := aString asString.
	^true! !

!UUniverseEditor methodsFor: 'networking' stamp: 'ls 2/13/2005 17:16'!
processNetworking
	client receivedMessagesDo: [ :message |
		message applyToEditor: self ].
! !

!UUniverseEditor methodsFor: 'package editing' stamp: 'ls 2/13/2005 17:20'!
removeVersion
	| package |
	self anyPackageSelected ifFalse: [ ^self ].
	self acceptFields.

	package := self selectedPackage.

	(self confirm: ('Delete ', 	package printString, '?')) ifFalse: [
		^self ].

	self sendMessage: (UMRemovePackage username: username password: password packageName: package name packageVersion: package version).
! !

!UUniverseEditor methodsFor: 'package list' stamp: 'ls 7/29/2004 16:23'!
requestPackageList
	self sendMessage: (UMRequestPackages new).
	! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 16:02'!
returnTrue
	^true! !

!UUniverseEditor methodsFor: 'package list' stamp: 'ls 2/13/2005 16:27'!
selectedPackage
	^self sortedPackages at: self selectedPackageIndex! !

!UUniverseEditor methodsFor: 'package list' stamp: 'ls 2/13/2005 16:27'!
selectedPackageIndex
	^selectedPackageIndex! !

!UUniverseEditor methodsFor: 'package list' stamp: 'ls 2/13/2005 16:27'!
selectedPackageIndex: anInteger
	selectedPackageIndex := anInteger.
	self changed: #selectedPackageIndex.
! !

!UUniverseEditor methodsFor: 'networking' stamp: 'ls 7/30/2004 15:40'!
sendMessage: aMessage
	client sendMessage: aMessage.
	! !

!UUniverseEditor methodsFor: 'package list' stamp: 'ls 2/13/2005 16:27'!
sortedPackages
	^universe packages asSortedCollection: [ :p1 :p2 |
		p1 name < p2 name or: [
			p1 name = p2 name and: [ p1 version < p2 version ] ] ].
	! !

!UUniverseEditor methodsFor: 'stepping' stamp: 'ls 7/28/2004 17:01'!
step
	self processNetworking! !

!UUniverseEditor methodsFor: 'stepping' stamp: 'ls 7/28/2004 17:01'!
stepTimeIn: window
	^10! !

!UUniverseEditor methodsFor: 'attributes' stamp: 'ls 7/29/2004 16:21'!
universeDescription 
	^universe description! !

!UUniverseEditor methodsFor: 'package list' stamp: 'ls 2/13/2005 16:27'!
update: aSymbol
	aSymbol = #packages ifTrue: [ self packagesChanged ]! !

!UUniverseEditor methodsFor: 'attributes' stamp: 'ls 7/28/2004 15:53'!
username
	^username! !

!UUniverseEditor methodsFor: 'attributes' stamp: 'ls 7/28/2004 16:13'!
username: aString
	username := aString asString.
	^true! !

!UUniverseEditor methodsFor: 'stepping' stamp: 'ls 7/28/2004 17:01'!
wantsSteps
	^true! !

Object subclass: #UUniverseMultiServer
	instanceVariableNames: 'servers port connectionQueue connections connectionVersions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Server'!

!UUniverseMultiServer commentStamp: 'ls 2/13/2005 14:51' prior: 0!
A multi-server server.  This listens on one port, and dispatches to whichever universe was requested.

An active server needs someone to call #step periodically on it, in order for it to process networking, save checkpoints, etc.!

!UUniverseMultiServer class methodsFor: 'defaults' stamp: 'ls 2/13/2005 14:32'!
defaultPort
	^3702! !

!UUniverseMultiServer methodsFor: 'networking' stamp: 'ls 2/15/2005 22:00'!
acceptConnection: stringSocket
	stringSocket nextPut: (UMProtocolVersion version: 1) asStringArray.
	connections add: stringSocket! !

!UUniverseMultiServer methodsFor: 'networking' stamp: 'ls 2/13/2005 14:29'!
acceptConnectionOn: socket
	self acceptConnection: (StringSocket on: socket).
	! !

!UUniverseMultiServer methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 14:33'!
addServer: server
	servers add: server! !

!UUniverseMultiServer methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 14:49'!
addServers: newServers
	newServers do: [ :s | self addServer: s ]! !

!UUniverseMultiServer methodsFor: 'networking' stamp: 'ls 2/13/2005 14:29'!
checkForNewConnections
	connectionQueue ifNil: [ ^self ].
	[ connections size < 100 ] whileTrue: [
		| newSocket |
		newSocket := connectionQueue getConnectionOrNil.
		newSocket ifNil: [ ^self ].
		connections add: (StringSocket on: newSocket) ].
	! !

!UUniverseMultiServer methodsFor: 'networking' stamp: 'ls 2/13/2005 14:30'!
destroyConnection: aConnection
	aConnection destroy.
	connections remove: aConnection ifAbsent: [].
	! !

!UUniverseMultiServer methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 14:33'!
initialize
	servers := Set new.
	port := UUniverseMultiServer defaultPort.
	connections := Set new.
! !

!UUniverseMultiServer methodsFor: 'networking' stamp: 'ls 2/13/2005 14:32'!
processConnection: aConnection
	| message |
	aConnection isConnected ifFalse: [ ^self destroyConnection: aConnection ].
	
	"process all incoming messages.  Note that some messages move the connection to one of the subsidiary servers, so be careful not to process messages after that happens"
	aConnection processIO.
	[ 	(connections includes: aConnection) and: [
			message := aConnection nextOrNil.
	 	 	message notNil ]
	] whileTrue: [
	  	self processRawMessage: message fromConnection: aConnection ].

	(connections includes: aConnection) ifFalse: [ ^self ].

	aConnection isConnected
		ifTrue: [ aConnection processIO.  "start sending out the response" ]
		ifFalse: [ self destroyConnection: aConnection ]
! !

!UUniverseMultiServer methodsFor: 'networking' stamp: 'ls 2/13/2005 14:30'!
processConnections
	connections copy do: [ :c |
		self processConnection: c ]! !

!UUniverseMultiServer methodsFor: 'networking' stamp: 'ls 2/13/2005 14:51'!
processNetworking
	self checkForNewConnections.
	self processConnections.
! !

!UUniverseMultiServer methodsFor: 'messages' stamp: 'ls 2/13/2005 14:34'!
processRawMessage: aStringArray  fromConnection: connection
	| message |
	message := UMessage fromStringArray: aStringArray.
	message applyToMultiServer: self forConnection: connection.
! !

!UUniverseMultiServer methodsFor: 'networking' stamp: 'ls 2/13/2005 16:08'!
startListening
	self stopListening.
	connectionQueue := ConnectionQueue portNumber: port queueLength: 5.
	! !

!UUniverseMultiServer methodsFor: 'stepping' stamp: 'ls 2/13/2005 14:50'!
step
	self processNetworking.
	servers do: [ :server | server step ].
! !

!UUniverseMultiServer methodsFor: 'networking' stamp: 'ls 2/13/2005 16:08'!
stopListening	
	connectionQueue ifNotNil: [
		connectionQueue destroy.
		connectionQueue := nil ].
	! !

!UUniverseMultiServer methodsFor: 'messages' stamp: 'ls 2/13/2005 16:18'!
switchConnection: aConnection  toServerNamed: serverName
	| server |
	server := servers detect: [ :s | s universe shortName = serverName ] ifNone: [
		aConnection nextPut: (UMError description: 'no such server here') asStringArray.
		^self ].

	server acceptConnection: aConnection.
	connections remove: aConnection.
! !

Object subclass: #UUniverseServer
	instanceVariableNames: 'universe policy saveDirectory packageListFilename lastSaveTime connectionQueue connections logfile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Server'!

!UUniverseServer commentStamp: 'ls 2/13/2005 13:45' prior: 0!
A server holding the authoratative information about a universe.  Clients may make requests to view and update the universe.

The server does not manage its own thread; it requires that processNetworking is called periodically.
!

!UUniverseServer class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 09:29'!
forSaveDirectory: aDirectory
	| universe |
	universe := self forUniverse: UUniverse new.
	universe saveDirectory: aDirectory.
	universe loadFromCheckpoint.
	^universe! !

!UUniverseServer class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 10:31'!
forUniverse: universe
	^self basicNew initializeForUniverse: universe.
	! !

!UUniverseServer class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 10:31'!
new
	^self shouldNotImplement ! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 2/15/2005 22:00'!
acceptConnection: stringSocket
	stringSocket nextPut: (UMProtocolVersion version: 1) asStringArray.
	connections add: stringSocket! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 11:02'!
acceptConnectionOn: socket
	self acceptConnection: (StringSocket on: socket).
	! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 13:15'!
checkForNewConnections
	connectionQueue ifNil: [ ^self ].
	[ connections size < 10 ] whileTrue: [
		| newSocket |
		newSocket := connectionQueue getConnectionOrNil.
		newSocket ifNil: [ ^self ].
		connections add: (StringSocket on: newSocket) ].
	! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 8/3/2004 18:10'!
comancheServiceName
	^'universe server on ', universe serverPort printString! !

!UUniverseServer methodsFor: 'editing' stamp: 'ls 7/29/2004 16:53'!
connection: connection requestedAccountChangeForUsername: username  password: password  newPassword: newPassword newEmail: newEmail
	| response |
	response := policy changeUser: username withPassword: password toHavePassword: newPassword andNewEmail: newEmail.
	response allowed ifFalse: [
		^self
			sendError: 'changing account for ', username, ' failed (', response reason, ')'
			onConnection: connection].
		
	self sendMessage: (UMEditedAccount username: username newPassword: newPassword newEmail: newEmail) onConnection: connection! !

!UUniverseServer methodsFor: 'editing' stamp: 'ls 7/29/2004 16:53'!
connection: connection requestedAccountWithUsername: username  password: password  email: email 
	| response |
	response := policy addUser: username withPassword: password andEmail: email.
	response allowed ifFalse: [
		self
			sendError: 'adding account for ', username, ' failed (', response reason, ')'
			onConnection: connection].! !

!UUniverseServer methodsFor: 'editing' stamp: 'ls 7/29/2004 16:54'!
connection: connection requestedForUsername: username  andPassword: password  toAddPackage: package
	| response |
	response := policy package: package mayBeAddedBy: username withPassword: password.
	
	response allowed
		ifFalse: [
			^self 
				sendError: 'adding package ', package name, ' failed (', response reason, ')'
				onConnection: connection].
		
	universe addPackage: package.


	self sendMessage: (UMPackageAdded package: package) onConnection: connection.! !

!UUniverseServer methodsFor: 'editing' stamp: 'ls 7/29/2004 16:54'!
connection: connection requestedForUsername: username  andPassword: password  toRemovePackageNamed: packageName withVersion: version
	| packagesToRemove response |
	response := policy packageNamed: packageName withVersion: version mayBeRemovedBy: username withPassword: password.
	
	response allowed ifFalse: [
		^self 
			sendError: 'removing package ', packageName, ' failed (', response reason, ')' 
			onConnection: connection].
		
	packagesToRemove := universe packages select: [ :p | p name = packageName and: [ p version = version ] ].
	packagesToRemove do: [ :p |
		universe removePackage: p ].
	
	self sendMessage: (UMPackageRemoved packageName: packageName version: version) onConnection: connection.! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 10:47'!
destroyConnection: aConnection
	aConnection destroy.
	connections remove: aConnection ifAbsent: [].! !

!UUniverseServer methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 15:20'!
initializeForUniverse: aUniverse
	universe := aUniverse.
	policy := UPolicy new.
	connectionQueue := nil.
	connections := Set new.
! !

!UUniverseServer methodsFor: 'persistence' stamp: 'ls 7/29/2004 09:25'!
loadFromCheckpoint
	"reload from a checkpoint"
	| file savedObject |
	(saveDirectory isAFileNamed: 'checkpoint')
		ifTrue: [ file := saveDirectory readOnlyFileNamed: 'checkpoint' ]
		ifFalse: [ file := saveDirectory readOnlyFileNamed: 'checkpoint.die' ].

	savedObject := file fileInObjectAndCode.
	file close.
	
	universe := savedObject first.
	policy := savedObject second.	! !

!UUniverseServer methodsFor: 'logging' stamp: 'ls 5/30/2007 11:40'!
logMessage: message
	| line |
	logfile ifNil: [ ^self ].
	line := message maybeLogMessage.
	line ifNil: [ ^self ].
	logfile
		print: DateAndTime now;
		space;
		nextPutAll: line; 
		cr.
	logfile flush.! !

!UUniverseServer methodsFor: 'logging' stamp: 'ls 5/28/2007 17:27'!
logToFileNamed: filename
	logfile := FileStream fileNamed: filename.
	logfile setToEnd.
	! !

!UUniverseServer methodsFor: 'stepping' stamp: 'ls 8/2/2004 17:15'!
openStepperMorph
	(UServerStepperMorph new server: self; yourself) openInWorld! !

!UUniverseServer methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 13:44'!
packageListFilename: filename
	packageListFilename := filename! !

!UUniverseServer methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:32'!
policy: aPolicy
	policy := aPolicy! !

!UUniverseServer methodsFor: 'persistence' stamp: 'ls 2/13/2005 15:23'!
possiblySaveCheckpointAndPackageList
	saveDirectory ifNil: [^self].
	(lastSaveTime isNil 
		or: [DateAndTime now - lastSaveTime > (Duration minutes: 30)]) 
			ifTrue: 
				[self saveCheckpoint.
				self savePackageList.
				lastSaveTime := DateAndTime now]! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 21:28'!
processConnection: aConnection
	| message |
	aConnection isConnected ifFalse: [ ^self destroyConnection: aConnection ].
	
	aConnection processIO.
	[ 	message := aConnection nextOrNil.
	  	message notNil
	] whileTrue: [
	  	self processRawMessage: message fromConnection: aConnection ].

	aConnection isConnected
		ifTrue: [ aConnection processIO.  "start sending out the response" ]
		ifFalse: [ self destroyConnection: aConnection ]! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 10:43'!
processConnections
	connections copy do: [ :c |
		self processConnection: c ]! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 2/13/2005 15:19'!
processNetworking
	self checkForNewConnections.
	self processConnections.
	! !

!UUniverseServer methodsFor: 'messages' stamp: 'ls 5/28/2007 17:32'!
processRawMessage: aStringArray  fromConnection: connection
	| message |
	message := UMessage fromStringArray: aStringArray.
	message applyToServer: self forConnection: connection.
	self logMessage: message.
	! !

!UUniverseServer methodsFor: 'persistence' stamp: 'ls 2/13/2005 13:43'!
saveCheckpoint
	"save a checkpoint"
	| tmpFile |
	saveDirectory deleteFileNamed: 'checkpoint.tmp'.
	
	tmpFile := saveDirectory newFileNamed: 'checkpoint.tmp'.
	(SmartRefStream on: tmpFile) nextPut: {universe.policy}; close.
	
	saveDirectory deleteFileNamed: 'checkpoint.die'.
	saveDirectory rename: 'checkpoint.tmp' toBe: 'checkpoint'.	
	saveDirectory deleteFileNamed: 'checkpoint.die'.
	! !

!UUniverseServer methodsFor: 'initialize-release' stamp: 'ls 7/29/2004 09:16'!
saveDirectory: aDirectory
	saveDirectory := aDirectory! !

!UUniverseServer methodsFor: 'persistence' stamp: 'ls 2/13/2005 13:44'!
savePackageList
	packageListFilename ifNotNil: [
		UPackage savePackageList: universe packages onFileNamed: packageListFilename ]! !

!UUniverseServer methodsFor: 'messages' stamp: 'ls 7/28/2004 14:49'!
sendError: description onConnection: stringSocket
	self sendMessage: (UMError description: description) onConnection: stringSocket! !

!UUniverseServer methodsFor: 'messages' stamp: 'ls 7/28/2004 11:48'!
sendMessage: aMessage  onConnection: connection
	connection nextPut: aMessage asStringArray  ! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 13:21'!
startListening
	self stopListening.
	connectionQueue := ConnectionQueue portNumber: universe serverPort queueLength: 5.
	! !

!UUniverseServer methodsFor: 'stepping' stamp: 'ls 2/13/2005 15:23'!
step
	"do any necessary periodic work, including polling the network connections"

	self processNetworking.
	self possiblySaveCheckpointAndPackageList! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 10:41'!
stopListening	
	connectionQueue ifNotNil: [
		connectionQueue destroy.
		connectionQueue := nil ].
	! !

!UUniverseServer methodsFor: 'accessing' stamp: 'ls 7/28/2004 13:08'!
universe
	^universe! !

Object subclass: #UUtilities
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Model'!

!UUtilities commentStamp: 'ls 7/28/2004 10:35' prior: 0!
Universe miscellania that belong to no particular object.
!

Magnitude subclass: #UVersion
	instanceVariableNames: 'components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Model'!

!UVersion commentStamp: '<historical>' prior: 0!
A relatively simple hierarchical version number.!

!UVersion class methodsFor: 'instance creation' stamp: 'ls 7/27/2004 17:24'!
fromComponents: components
	^self basicNew components: components; yourself! !

!UVersion class methodsFor: 'instance creation' stamp: 'ls 7/27/2004 17:27'!
readFrom: stream
	| components |
	components := OrderedCollection new.
	[ stream atEnd ] whileFalse: [
		stream peek isDigit ifTrue: [
			components add: (Integer readFrom: stream) ]
		ifFalse: [
			components add: (String streamContents: [ :compStr |
				[ stream atEnd not and: [ stream peek isDigit not ] ] whileTrue: [
					compStr nextPut: stream next ] ]) ] ].
		
	^self fromComponents: components! !

!UVersion methodsFor: 'comparing' stamp: 'ls 7/27/2004 21:15'!
< aVersion
	| numToCompare |
	numToCompare := components size min: aVersion components size.
	(components first: numToCompare) with: (aVersion components first: numToCompare) do: [ :myComp :itsComp |
		(myComp uversionLessThan: itsComp) ifTrue: [
			^true ].
		(itsComp uversionLessThan: myComp) ifTrue: [
			^false ] ].
	
	^components size < aVersion components size! !

!UVersion methodsFor: 'comparing' stamp: 'ls 7/27/2004 17:31'!
= aVersion
	components size = aVersion components size ifFalse:[ ^false ].

	components with: aVersion components do: [ :myComp :itsComp |
		(myComp uversionEqual: itsComp) ifFalse: [
			^false ] ].
	
	^true! !

!UVersion methodsFor: 'conversion' stamp: 'ls 8/26/2007 09:15'!
asUVersion
	^self! !

!UVersion methodsFor: 'attributes' stamp: 'ls 7/27/2004 17:33'!
components
	^components! !

!UVersion methodsFor: 'initialization' stamp: 'ls 7/27/2004 17:27'!
components: aCollection
	components := aCollection! !

!UVersion methodsFor: 'comparing' stamp: 'ls 7/28/2004 10:02'!
hash
	^components inject: 1 into: [ :tally :new |
		(tally bitXor: new hash) hashMultiply ]! !

!UVersion methodsFor: 'printing' stamp: 'ls 7/27/2004 17:28'!
printOn: aStream
	components do: [ :comp | aStream nextPutAll: comp asString ].! !

Morph subclass: #UServerStepperMorph
	instanceVariableNames: 'server'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Server'!

!UServerStepperMorph commentStamp: '<historical>' prior: 0!
A morph that simply steps a UniverseServer continuously.
!

!UServerStepperMorph methodsFor: 'closing' stamp: 'ls 2/13/2005 15:20'!
delete
	super delete.
	server stopListening.
! !

!UServerStepperMorph methodsFor: 'initialization' stamp: 'ls 7/28/2004 13:19'!
server: aServer
	server := aServer! !

!UServerStepperMorph methodsFor: 'stepping' stamp: 'ls 8/14/2007 20:58'!
step
	server ifNotNil: [ server step ].
! !

!UServerStepperMorph methodsFor: 'stepping' stamp: 'ls 7/28/2004 13:19'!
stepTime
	^10! !

!UServerStepperMorph methodsFor: 'stepping' stamp: 'ls 7/28/2004 13:19'!
wantsSteps
	^true! !

TestCase subclass: #UGlobalInstallerTest
	instanceVariableNames: 'universe'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Tests'!

!UGlobalInstallerTest methodsFor: 'Running' stamp: 'ls 1/16/2005 14:11'!
setUp
	| package |
	universe := UStandardUniverse new.
	
	package := UPackage new.
	package name: 'A'.
	package addDependency: 'B'.
	universe addPackage: package.
	
	package := UPackage new.
	package name: 'B'.
	package addDependency: 'C'.
	universe addPackage: package.
	
	package := UPackage new.
	package name: 'C'.
	package addDependency: 'D'.
	package addDependency: 'E'.
	universe addPackage: package.
	
	package := UPackage new.
	package name: 'D'.
	universe addPackage: package.
	
	package := UPackage new.
	package name: 'E'.
	universe addPackage: package.

	package := UPackage new.
	package name: 'Broken'.
	package addDependency: 'NonExistent'.
	universe addPackage: package.
	
! !

!UGlobalInstallerTest methodsFor: 'Running' stamp: 'ls 8/14/2007 21:41'!
testBasicDependency
	| installer neededPackages |
	installer := UGlobalInstaller universe: universe.
	neededPackages := installer 
				allPackagesNeededToInstall: (universe newestPackageNamed: 'A')
				orIfImpossible: [:ign | self error: 'dependency not found'].
	self should: [neededPackages size = 5].
	
	
	installer := UGlobalInstaller universe: universe.
	neededPackages := installer 
				allPackagesNeededToInstall: (universe newestPackageNamed: 'B')
				orIfImpossible: [:ign | self error: 'dependency not found'].
	self should: [neededPackages size = 4]! !

!UGlobalInstallerTest methodsFor: 'Running' stamp: 'ls 8/14/2007 21:42'!
testBrokenDependency
	| installer neededPackages |
	installer := UGlobalInstaller universe: universe.
	neededPackages := installer allPackagesNeededToInstall: (universe newestPackageNamed: 'Broken')  orIfImpossible: [ :ign | nil ].
	self should: [ neededPackages isNil ].

	! !

TestCase subclass: #UPackageTestCase
	instanceVariableNames: 'p1 p2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Tests'!

!UPackageTestCase methodsFor: 'setup' stamp: 'ls 11/26/2006 11:10'!
setUp
	p1 := UPackage new.
	p1 name: 'Scamper'.
	p1 category: (UPackageCategory withComponents: #('Networking')).
	p1 description: 'A web browser'.
	p1 url: 'http://www.squeak.org' asUrl.
	p1 homepage: p1 url.
	p1 version: (UVersion readFromString: '1.0').
	p1 maintainer: 'John Doe'.

	p2 := p1 deepCopy.
! !

!UPackageTestCase methodsFor: 'comparing' stamp: 'ls 8/26/2007 12:00'!
testCompare
	self should: [ p1 = p2 ].
	self should: [ p1 hash = p2 hash ].

	p2 homepage: 'http://www.squeakland.org' asUrl.
	self shouldnt: [ p1 = p2 ].

	p2 homepage: p1 homepage.
	self should: [ p1 = p2 ].
	self should: [ p1 hash = p2 hash ].

	p1 homepage: nil.
	p2 homepage: nil.
	self should: [ p1 = p2 ].
	self should: [ p1 hash = p2 hash ].

	p2 maintainer: 'Jane'.
	self shouldnt: [ p1 = p2 ].! !

!UPackageTestCase methodsFor: 'comparing' stamp: 'ls 2/13/2005 12:59'!
testEncoding
	self should: [ p1 = (UPackage decodeFromStringStream: (ReadStream on: p1 stringArrayEncoding)) ].! !

!UPackageTestCase methodsFor: 'comparing' stamp: 'ls 11/26/2006 10:50'!
testXML
	| xmlString stream readp1 readp2 readPackages readp3 |
	p2 version: (UVersion readFromString: '1.2').
	p1 description: 'blah blah <>&"'''.

	xmlString := String streamContents: [ :str |
		str 
			nextPutAll: p1 xmlForExport;
			nextPutAll: p2 xmlForExport.
			
		str nextPutAll: '<package>
<name>IRCe</name>
<version>10.7.6</version>
<description>This is a significant rewrite of the built-in Squeak IRC client GUI. A new user interface includes having one console window per connection and then having all console messages, channel messages and private messages contained inside the main console window using tabbed swapped panes.                                         

Numerous other changes are also included but are not described here. The change-set contains documentation for all features added or modified.

Instructions at http://squeak.preeminent.org/irc-help/irc-help.html</description>
<url>http://kilana.unibe.ch:8888/IRC/Network-IRC-fc.10.7.6.mcz</url>
<maintainer></maintainer>
<provides></provides><depends></depends><conflicts></conflicts></package>' ].

	stream := ReadStream on: xmlString.
	readPackages := UPackage decodePackagesFromXMLStream: stream.

	self should: [ readPackages size = 3 ].
	readp1 := readPackages first.
	readp2 := readPackages second.
	readp3 := readPackages third.

	self should: [ readp1 = p1 ].
	self should: [ readp2 = p2 ].
	self should: [ readp3 name = 'IRCe'].
	self should: [ readp3 version = (UVersion readFromString: '10.7.6')].
	! !

TestCase subclass: #UUniverseServerTestCase
	instanceVariableNames: 'server'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Tests'!

TestCase subclass: #UVersionTestCase
	instanceVariableNames: 'typicalVersions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Tests'!

!UVersionTestCase methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:12'!
setUp
	typicalVersions := #(
		'1'
		'2'
		'1.5.7'
		'1.5.8'
		'1.6.2'
		'1.5'
		'1.5a'
		'1.5b'
		'1.6'
		'alpha'
		'beta'
	) collect: [ :str | UVersion readFromString: str ].
	! !

!UVersionTestCase methodsFor: 'Running' stamp: 'ls 7/27/2004 17:19'!
testCompare
	self should: [ (UVersion readFromString: '1') < (UVersion readFromString: '2') ].
	self should: [ (UVersion readFromString: '1.5.7') < (UVersion readFromString: '1.5.8') ].
	self should: [ (UVersion readFromString: '1.5.7') < (UVersion readFromString: '1.6.2') ].
	self should: [ (UVersion readFromString: '1.5') < (UVersion readFromString: '1.5a') ].
	self should: [ (UVersion readFromString: '1.5a') < (UVersion readFromString: '1.5b') ].
	self should: [ (UVersion readFromString: '1.5b') < (UVersion readFromString: '1.6') ].! !

!UVersionTestCase methodsFor: 'Running' stamp: 'ls 7/27/2004 17:24'!
testFullOrder
	"check that all versions are in some order"

	typicalVersions do: [ :v1 |
		typicalVersions do: [ :v2 |
			self should: [
				(v1 < v2)
				or: [ (v2 < v1) 
				or: [ v1 = v2 ] ] ] ] ]



	! !

!UVersionTestCase methodsFor: 'Running' stamp: 'ls 7/28/2004 09:59'!
testHash
	typicalVersions do: [ :v |
		self should: [ v hash = v copy hash ] ].
	
	self should: [ (UVersion readFromString: '1.5a') hash = (UVersion readFromString: '1.5a') hash ].! !

!UVersionTestCase methodsFor: 'Running' stamp: 'ls 7/27/2004 17:23'!
testReversedComparisons
	"check that it is never the case that v1<v2 and v2<v1"

	typicalVersions do: [ :v1 |
		typicalVersions do: [ :v2 |
			self should: [ (v1 < v2) not  or:  [  (v2 < v1) not ] ] ] ].

	! !

!StringSocket class methodsFor: '*universes' stamp: 'ls 8/3/2004 18:04'!
decodeStringArray: aString
	| idx numStrings |
	idx := 1.
	numStrings := aString getInteger32: idx.
	idx := idx + 4.
	numStrings < 0 ifTrue: [ ^self error: 'invalid string socket encoding' ].
	numStrings > 10000000 ifTrue: [ self error: 'refusing to decode humongous string socket' ].
	
	^(1 to: numStrings) collect: [ :ignored |
		| size str |
		size := aString getInteger32: idx.
		idx := idx + 4.
		str := aString copyFrom: idx to: idx+size-1.
		idx := idx + size.
		str ]
	! !

!StringSocket class methodsFor: '*universes' stamp: 'ls 8/2/2004 16:18'!
encodeStringArray: stringArray
	| size outBuf outBufIndex |
	size := self spaceToEncode: stringArray.
	
	outBuf := String new: size.
	outBufIndex := 1.

	outBuf putInteger32: stringArray size at: outBufIndex.
	outBufIndex := outBufIndex + 4.
	stringArray do: [ :each |
		outBuf putInteger32: each size at: outBufIndex.
		outBufIndex := outBufIndex + 4.
		outBuf 
			replaceFrom: outBufIndex 
			to: outBufIndex + each size - 1 
			with: each 
			startingAt: 1.
		outBufIndex := outBufIndex + each size.
	].
	
	^outBuf! !

!StringSocket class methodsFor: '*universes' stamp: 'ls 8/2/2004 16:18'!
spaceToEncode: stringArray
	^stringArray inject: 4 into: [ :sum :array |
		sum + (array size + 4) ].! !
UAccountEditor initialize!
UPackageEditor initialize!
UUniverse initialize!
UUniverseBrowser initialize!
UPackageInstaller initialize!
UUniverseClient initialize!
UUniverseEditor initialize!
